//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#property strict
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
#ifdef __MQL5__
#define   OP_BUY     0
#define   OP_SELL    1
#endif 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
enum TradingMode
  {
   BUYONLY,   // Buy Only
   SELLONLY,  // Sell Only
   ALL        // ALL
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
enum DIRECTION
  {
   REVERSION,  // Reversion
   BREAKOUT,   // Break Out
   BOTH        // Both
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+  
input string                  Entry=  "===== ENTRY =====";                                                 // ===== ENTRY =====
input string                  Include_Symbols         = "EURUSD,GBPUSD,AUDUSD";                            // Include Symbols
input string                  Control_Magics          = "";                                                // Control Magics
input bool                    Control_All_Positions   = true;                                             // Control ALL Positions
input int                     Max_Entries_On_Friday   = 99;                                                // Max Entries On Friday (0 => NONE)
input int                     Max_Entries_Daily       = 0;                                                 // Max Entries Daily (0 => UNLIMITED)
input TradingMode             Entry_Type              = ALL;                                               // Allowed Entries

input string                  _DayRange=  "===== DAY RANGE =====";                                         // ===== DAY RANGE =====
input bool                    Use_Day_Range_Indicator = false;                                             // Use Day Range
input string                  Indicator_Name          = "DayHistoryRange";                                 // Indiator File Name
input int                     Start_Year              = 2008;                                              // Start Year
input int                     MidDaysForCalculations  = 4;                                                 // Min Days for Calculations
input DIRECTION               DR_Trading_Mode         = BREAKOUT;                                          // Day Range Traiding mode
input double                  Min_BreakOut_Distance   = 20.0;                                              // Min Break Out Distance, pips
input double                  Signal_Filter           = 100.0;                                             // Signal Filter, pips
input double                  Min_Day_Open_Distance   = 0.0;                                               // Min Day Open Distance
input bool                    DR_On_Cross_Only        = false;                                             // Entry On Cross Only
input bool                    DR_Close_On_Opposite    = false;                                             // Close On Opposite Signal

input string                  _ATR=  "===== ATR =====";                                                    // ===== ATR =====
input bool                    Use_ATR_Entry_Signal    = false;                                              // Use ATR Entry Signal
input bool                    ATR_BreakOut_Mode       = false;                                             // ATR Break Out Mode
input ENUM_TIMEFRAMES         ATR_Time_Frame          = PERIOD_D1;                                         // ATR Time Frame
input int                     ATR_Period              = 14;                                                // ATR Period
input double                  ATR_Multiplier          = 0.8;                                               // ATR Multiplier  
input double                  ATR_Minimum             = 0.0;                                               // ATR Minimum, pips 
input int                     High_Low_Period         = 24;                                                // High/Low Period, hours 
input double                  New_Mark_Distance       = 0.0;                                               // New Mark Retrace, pips (0 => Off)
input bool                    Entry_On_Signal_Cross   = false;                                             // Entry On Signal Cross

input string                  _MAs=  "===== MOVING AVERAGEs =====";                                        // ===== MOVING AVERAGES =====
input bool                    Use_Moving_Averages     = false;                                             // Use Moving Averages
input ENUM_TIMEFRAMES         MAs_Time_Frame          = PERIOD_D1;                                         // MA Time Frame
input int                     MA_Fast_Period          = 50;                                                // Fast MA Period
input int                     MA_Slow_Period          = 100;                                               // Slow MA Period
input ENUM_MA_METHOD          MAs_Method              = MODE_SMA;                                          // MA Method
input ENUM_APPLIED_PRICE      MAs_Applied_Price       = PRICE_CLOSE;                                       // MA Applied Price
input bool                    Close_At_Opposite       = false;                                             // Close at Opposite Signal
input bool                    Reopen_Basket           = false;                                             // Reopen Basket

input string                  Trading=  "===== TRADING =====";                                             // ===== TRADING =====
input double                  Take_Profit             = 9;                                                 // Take Profit, pips (0 => OFF)
input bool                    Disable_If_Trailed      = false;                                             // Disable TP if Trailed
input double                  Stop_Loss               = 0;                                                 // Stop Loss, $ (0 => OFF)
input bool                    Disable_For_Basket      = false;                                             // Disable Stop for Basket
input bool                    Use_Time_Zone_First     = false;                                             // Enable Time Zone For First Averaging
input string                  Time_Zone_First_Start   = "08:00";                                           // Time Zone FirstAv start
input string                  Time_Zone_First_End     = "12:00";                                           // Time Zone FirstAv end
input double                  Max_Net_Lot             = 3.0;                                               // Max Net Lot
input double                  Default_Lot             = 0.01;                                              // Default Start Lot
input string                  Start_Lots              = "";                                                // Start Lots ("PAIR1:LOT1,PAIR2:LOT2,PAIR3:LOT3");
input int                     Max_Orders              = 50;                                                // Max Orders
input bool                    Close_At_23             = false;                                             // Close at 23:00
input bool                    Split_Lots_When_Limit   = true;                                             // Split Lots when Limit Reached
#ifdef __MQL5__
sinput ENUM_ORDER_TYPE_FILLING Order_Filling_Type=ORDER_FILLING_FOK;                                 // Order Filling Type
#endif 

input string                  Trending=  "===== TRENDING =====";                                           // ===== TRENDING =====
input bool                    Allow_Trending          = false;                                             // Allow Pyramiding
input double                  Orders_Step             = 30.0;                                              // Orders Step
input double                  Prev_Lot_Multiplier     = 1.0;                                               // Prev Lot Multiplier
input int                     Max_Orders_Pyramid      = 10;                                                // Max Orders Pyramid
input double                  Min_Profit_if_Pyramid   = 0;                                                 // Min Profit if Pyramid, $ (0 => OFF)

input string                  Averaging=  "===== AVERAGING =====";                                         // ===== AVERAGING =====
input double                  Keep_Distance_to_BE     = 40;                                                 // Keep Distance to BE, pips (0 => OFF)
input int                     Min_Averaging_Time_Sec  = 600;                                                 // Minimum Time between Averaging, sec
input double                  Min_Averaging_Pips      = 30;                                               // Minimum Averaging Distance, pips
input double                  Min_Averaging_First     = 60;                                               // Min Averaging Start, pips
input bool                    Use_Averaging_By_ATR    = false;                                             // Averaging By ATR
input double                  ATR_Averaging_Value     = 0;                                                 // ATR Averaging Value
input double                  Max_Loss_At_Reverse_Pips= 90.0;                                              // Max Loss at Reverse, pips
input double                  Close_At_Max_Lot        = 0;                                                 // Close at Max Lot, Lot %
input int                     Max_Close_Times         = 0;                                                 // Max Closing Times
input double                  Start_Lot_To_Apply      = 0.0;                                               // Start Lot to Apply
input bool                    Use_DR_Filter           = false;                                             // Use Day Range Filter
input double                  Max_Lot_ToApplyDRFilter = 0.5;                                               // Max Lot to apply filter
input double                  Channel_Bigger_Than     = 180.0;                                             // Channel Bigger than, pips
input double                  Allowed_Range_Inside    = 50.0;                                              // Allowed Range Inside, pips
input double                  Allowed_Range_Out       = 0.0;                                               // Allowed Range Outside, pips
input double                  Channel_Smaller_Than    = 120.0;                                             // Channel Smaller than, pips
input double                  Allowed_Range_Outside   = 50.0;                                              // Allowed Range Outside, pips

input string                  Trailing=      "===== TRAILING STOP =====";                                  // ===== TRAILING STOP =====
input bool                    Trailing_Stop           = false;                                             // Enable Trailing Stop
input double                  Trail_Start_Lot         = 0.5;                                               // Trailing Stop Start Lot
input double                  Trailing_Stop_Start_p   = 50.0;                                              // Trailing Stop Start Level, pips
input double                  Trailing_Stop_Distance_p= 20.0;                                              // Trailing Stop Distance, pips
input double                  Trailing_Stop_Max_Pips  = 1.0;                                               // TSL Max pips, (0 => OFF)

input string                  TimeFilters=   "===== TIME FILTER =====";                                    // ===== TIME FILTER =====
input bool                    Use_Time_Zone_1         = true;                                             // Enable Time Zone #1
input string                  Time_Zone_1_Start       = "02:10";                                           // Time Zone #1 start
input string                  Time_Zone_1_End         = "22:40";                                           // Time Zone #1 end
input bool                    Use_Time_Zone_2         = false;                                             // Enable Time Zone #2
input string                  Time_Zone_2_Start       = "14:00";                                           // Time Zone #2 start
input string                  Time_Zone_2_End         = "16:00";                                           // Time Zone #2 end

input string                  Execution=  "===== EXECUTION =====";                                         // ===== EXECUTION =====
input double                  Slippage                = 0.1;                                               // Max Slippage, pips
input ulong                   Magic                   = 1000000;                                           // EA Magic Number
input string                  Max_Spreads             = "";                                                // Max Spreads ("PAIR1:SPREAD1,PAIR2:SPREAD2,PAIR3:SPREAD3");

input string                  Notification="===== NOTIFICATIONS =====";                                    // ===== NOTIFICATIONS =====
input bool                    Journaling              = false;                                              // Journaling (Experts or Journal Tab)
input bool                    Log                     = false;                                              // Log File (Experts/Files)
input bool                    Alerts                  = false;                                             // MT Alerts

input string                  _DD_Alerts=         "===== DD ALERTS =====";                                 // ===== DD ALERTS =====
input string                  _Portfolio_Comment      = "PM EA 7.1";                               // Portfolio Comment
input double                  DD_Threshold_Start      = 200.0;                                             // DD Alert Threshold start, $
input double                  DD_Threshold_Step       = 100.0;                                             // DD Alert Threshold step, $
input double                  Critical_DD             = 400.0;                                             // Critical DD, $
input int                     Send_at_Hour_1          = 9;                                                 // Send @ Hour #1
input int                     Send_at_Hour_2          = 17;                                                // Send @ Hour #2

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//===== DISPLAY SETTINGS
bool                    Show_Comments           = true;                             // Show EA Info
color                   Text_Color              = clrWhite;                         // Text Color 
string                  Font_Name               = "Tahoma";                         // Text Font Name
int                     Font_Size               = 9;                                // Text Font Size
ENUM_BASE_CORNER        Corner                  = CORNER_LEFT_UPPER;                // Anchor Corner
ENUM_ANCHOR_POINT       Anchor                  = ANCHOR_LEFT;                      // Anchor Point
int                     OffSet                  = 10;                               // Offset From corner, pixels
int                     dy                      = 22;                               // Space Between Rows, pixels
int                     dx                      = 90;                               // Space Between Columns, pixels
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string    prefix="";

string    worksymbols[];
double    pipstobuy[];
double    pipstosell[];
double    triggerpips[];
//=====
int       magics[];
//=====
int       fastMAHandles[];
int       slowMAHandles[];
int       ATRHandles[];
int       DRHandles[];

color     BKG_Color            = clrBlue;
string    status               = "ALL OK!";

string   SpreadSymbols[];
double   SpreadMax[];
string   SpreadStrings[];
int      customspread=0;

string   LotSymbols[];
double   LotValue[];
string   LotStrings[];
int      customlot=0;

double   survivedmove=0;

string Portfolio_Comment="";

datetime inittime=0;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
struct tradesinfo
  {
   string            symbol;
   int               orders;
   int               type;
   double            netlots;
   double            netpipstobe;
   double            currentpnl;
   double            historypnl;
   int               nextorderinsec;
  };
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+  
tradesinfo  pairsdata[];
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
struct gv
  {
   string            name;
   double            value;
   datetime          lastused;
  };

bool     Use_MT4_GVs       = false;                // Set true if want to use GlobalVariables from MT4
int      GVs_Flush_Period  = 7;                    // Flush not more often than, if updated, seconds    
int      GVs_Read_Period   = 150;                  // Update data from file, seconds
int      GVs_Life_Period   = 2419200;/*1month*/    // Remove unuesed after, seconds

gv GVs[];
bool flush            = true;
datetime lastgvsflush = 0;
datetime lastgvsread  = 0;
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OnInit()
  {
//=====
   RefreshWorkingSymbols();
//=====
   if(#ifdef __MQL4__ !MQLInfoInteger(MQL_TESTER) && #endif  !EventSetTimer(1))
     {
      Informer("Can not Set Timer. EA won't start. Please, check and try again.",_Symbol);
      ExpertRemove();
      return(INIT_FAILED);
     }

//=====
   if(!MQLInfoInteger(MQL_TESTER))
      prefix="PM_"+(string)Magic+"_"+(string)AccountInfoInteger(ACCOUNT_LOGIN)+"_";
   else
      prefix="test_PM_"+(string)Magic+"_"+(string)AccountInfoInteger(ACCOUNT_LOGIN)+"_";

//=====
   if(MQLInfoInteger(MQL_TESTER))
     {
      for(int i=0;i<ArraySize(worksymbols);i++)
        {
         //=====
         GVSet("DailyEntries "+(string)0+worksymbols[i],0);
         GVSet("DailyEntries "+(string)1+worksymbols[i],0);
         //=====
         GVSet("Kill "+(string)0+worksymbols[i],0);
         GVSet("Kill "+(string)1+worksymbols[i],0);
         //=====
        }
     }

//=====
   if(!GVsRead())
     {
      Informer("Can not Get EA data. EA won't start. Please, check and try again.",_Symbol,"Error Geting EA data.");
      ExpertRemove();
      return(INIT_FAILED);
     }

//=====
   if(!MQLInfoInteger(MQL_TESTER))
     {
      if(GVGet("SOFTEXIT")==0)
         GVSet("SOFTEXIT",1);
     }

//=====
   DeleteObjects();

//===== Process Magics
   string magicsstring[];
   int mgs=StringSplit(Control_Magics,StringGetCharacter(",",0),magicsstring);

   ArrayResize(magics,ArraySize(magicsstring));
   for(int i=0;i<ArraySize(magicsstring);i++)
      magics[i]=(int)StringToInteger(magicsstring[i]);

//===== Process Spreads
   customspread=StringSplit(Max_Spreads,StringGetCharacter(",",0),SpreadStrings);
   if(customspread>0)
     {
      ArrayResize(SpreadSymbols,customspread);
      ArrayResize(SpreadMax,customspread);

      for(int i=0;i<customspread;i++)
        {
         SpreadSymbols[i]=StringSubstr(SpreadStrings[i],0,6);
         SpreadMax[i]=StringToDouble(StringSubstr(SpreadStrings[i],7));
         Print("Max Spread: "+SpreadSymbols[i]+" | "+(string)SpreadMax[i]);
        }
     }

//===== Process Lots
   customlot=StringSplit(Start_Lots,StringGetCharacter(",",0),LotStrings);
   if(customlot>0)
     {
      ArrayResize(LotSymbols,customlot);
      ArrayResize(LotValue,customlot);

      for(int i=0;i<customlot;i++)
        {
         LotSymbols[i]=StringSubstr(LotStrings[i],0,6);
         LotValue[i]=StringToDouble(StringSubstr(LotStrings[i],7));
         Print("Lot: "+LotSymbols[i]+" | "+(string)LotValue[i]);
        }
     }
//=====
   Comment("");
   inittime=TimeLocal();
//=====
   Portfolio_Comment=_Portfolio_Comment+AccountInfoString(ACCOUNT_NAME);
//=====
   survivedmove=GetTrendMoveReal(FirstLot(_Symbol),Max_Net_Lot);
//===== 

//===== INDICATOR HANDLES
#ifdef __MQL5__
   int size=ArraySize(worksymbols);

   ArrayResize(fastMAHandles,size);
   ArrayResize(slowMAHandles,size);
   ArrayResize(ATRHandles,size);
   ArrayResize(DRHandles,size);

   for(int i=0;i<size;i++)
     {
      fastMAHandles[i]=iMA(worksymbols[i],MAs_Time_Frame,MA_Fast_Period,0,MAs_Method,MAs_Applied_Price);
      slowMAHandles[i]=iMA(worksymbols[i],MAs_Time_Frame,MA_Slow_Period,0,MAs_Method,MAs_Applied_Price);
      ATRHandles[i]=iATR(worksymbols[i],ATR_Time_Frame,ATR_Period);
      if(Use_Day_Range_Indicator)DRHandles[i]=iCustom(worksymbols[i],PERIOD_CURRENT,Indicator_Name,Start_Year,MidDaysForCalculations);
     }
#endif    
//=====

//===== 
   return(INIT_SUCCEEDED);
//=====
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnTimer()
  {
//===== Manage GVs
   if(flush && TimeLocal()-lastgvsflush>=GVs_Flush_Period)
     {
      if(GVsFlush())
        {
         //=====
         flush=false;
         lastgvsflush=TimeLocal();
         //=====
         if(TimeLocal()-lastgvsread>=GVs_Read_Period)
           {
            if(GVsRead())lastgvsread=TimeLocal();
            else Informer("ERROR: Can Not Read GVs file!!! "+(string)GetLastError(),_Symbol,"ERROR Reading GVs Data");
           }
        }
     }
//===== Main Execution
   Run();
//=====   
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnTick()
  {
   if(!MQLInfoInteger(MQL_TESTER))
      return;
//=====
   if(NewBar(_Symbol,PERIOD_D1))
     {
      for(int i=0;i<ArraySize(worksymbols);i++)
        {
         //=====
         GVSet("DailyEntries "+(string)0+worksymbols[i],0);
         GVSet("DailyEntries "+(string)1+worksymbols[i],0);
        }
     }
//===== Main Execution
   Run();
//=====   
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool DRAveragingFilter(const int symbindex,const int type,const double currlots)
  {
//=====
   if(!Use_DR_Filter || currlots>=Max_Lot_ToApplyDRFilter)return(true);
//=====

//=====
   if(symbindex<0 || symbindex>=ArraySize(worksymbols))return(false);
//=====

   double channelup=HistoryRangeUpperLine(symbindex,0);
   double channeldn=HistoryRangeLowerLine(symbindex,0);

   if(channeldn==0 || channelup==0)return(true);
   string SYMBOL=worksymbols[symbindex];
   ushort P=GetPoint(SYMBOL);
   double point=SymbolInfoDouble(SYMBOL,SYMBOL_POINT);
   double bid=SymbolInfoDouble(SYMBOL,SYMBOL_BID);
//=====
   if(channelup-channeldn>=Channel_Bigger_Than*P*point)
     {
      if(type==OP_BUY){if(bid>channeldn+Allowed_Range_Inside*P*point || (bid<channeldn && bid>channeldn-Allowed_Range_Out*P*point))return(false);}
      if(type==OP_SELL){if(bid<channelup-Allowed_Range_Inside*P*point || (bid>channelup && bid<channelup+Allowed_Range_Out*P*point))return(false);}
     }
//=====
   if(channelup-channeldn<=Channel_Smaller_Than*P*point)
     {
      if(type==OP_BUY){if(bid>channeldn-Allowed_Range_Outside*P*point)return(false);}
      if(type==OP_SELL){if(bid<channelup+Allowed_Range_Outside*P*point)return(false);}
     }
//=====
//=====
   return(true);
//=====
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void RefreshWorkingSymbols()
  {
//=====
   if(!MQLInfoInteger(MQL_TESTER))
     {
      //======
      int symbols=SymbolsTotal(true);
      //=====
      ArrayResize(worksymbols,0);
      ArrayResize(pipstobuy,0);
      ArrayResize(pipstosell,0);
      ArrayResize(triggerpips,0);
      //=====
      for(int i=0;i<symbols;i++)
        {
         //=====
         string symbolname=SymbolName(i,true);
         //=====
         if(StringFind(Include_Symbols,symbolname)>=0)
           {
            //=====
            int size=ArraySize(worksymbols);
            //=====
            ArrayResize(worksymbols,size+1);
            ArrayResize(pipstobuy,size+1);
            ArrayResize(pipstosell,size+1);
            ArrayResize(triggerpips,size+1);
            //=====
            worksymbols[size]=symbolname;
            Print(symbolname);
            //=====
           }
        }
     }
   else
     {
      ArrayResize(worksymbols,1);
      worksymbols[0]=Symbol();
      ArrayResize(worksymbols,1);
      ArrayResize(pipstobuy,1);
      ArrayResize(pipstosell,1);
      ArrayResize(triggerpips,1);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+,
double FastMA(int symbindex,int bar)
  {
//=====
   if(symbindex<0 || symbindex>=ArraySize(worksymbols))return(0);
//=====

#ifdef __MQL5__
   if(symbindex>=ArraySize(fastMAHandles))return(0);
   double ma[1]={0};
   CopyBuffer(fastMAHandles[symbindex],0,bar,1,ma);
   return(ma[0]);
#endif   
//=====  
#ifdef __MQL4__  
//=====
   return(iMA(worksymbols[symbindex],MAs_Time_Frame,MA_Fast_Period,0,MAs_Method,MAs_Applied_Price,bar));
//=====
#endif 
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double HistoryRangeUpperLine(int symbindex,int bar)
  {
//=====
   if(symbindex<0 || symbindex>=ArraySize(worksymbols))return(0);
//=====

#ifdef __MQL5__
   if(!Use_Day_Range_Indicator || symbindex>=ArraySize(DRHandles) || DRHandles[symbindex]==INVALID_HANDLE)return(0);
   double value[1]={0};
   CopyBuffer(DRHandles[symbindex],0,bar,1,value);
   return(value[0]);
#endif    
//=====  
#ifdef __MQL4__  
//=====
   if(!Use_Day_Range_Indicator)return(0);
   return(iCustom(worksymbols[symbindex],PERIOD_CURRENT,Indicator_Name,Start_Year,MidDaysForCalculations,0,bar));
//=====
#endif
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double HistoryRangeLowerLine(int symbindex,int bar)
  {
//=====
   if(symbindex<0 || symbindex>=ArraySize(worksymbols))return(0);
//=====

#ifdef __MQL5__
   if(!Use_Day_Range_Indicator || symbindex>=ArraySize(DRHandles) || DRHandles[symbindex]==INVALID_HANDLE)return(0);
   double value[1]={0};
   CopyBuffer(DRHandles[symbindex],1,bar,1,value);
   return(value[0]);
#endif    
//=====  
#ifdef __MQL4__  
//=====
   if(!Use_Day_Range_Indicator)return(0);
   return(iCustom(worksymbols[symbindex],PERIOD_CURRENT,Indicator_Name,Start_Year,MidDaysForCalculations,1,bar));
//=====
#endif
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double ATR(int symbindex,int bar)
  {
//=====
   if(symbindex<0 || symbindex>=ArraySize(worksymbols))return(0);
//=====

#ifdef __MQL5__
   if(symbindex>=ArraySize(ATRHandles))return(0);
   double atr[1]={0};
   CopyBuffer(ATRHandles[symbindex],0,bar,1,atr);
   return(atr[0]);
#endif  
//=====    
#ifdef __MQL4__  
//=====
   return(iATR(worksymbols[symbindex],ATR_Time_Frame,ATR_Period,bar));
//=====
#endif   
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double SlowMA(int symbindex,int bar)
  {
//=====
   if(symbindex<0 || symbindex>=ArraySize(worksymbols))return(0);
//=====

#ifdef __MQL5__
   if(symbindex>=ArraySize(slowMAHandles))return(0);
   double ma[1]={0};
   CopyBuffer(slowMAHandles[symbindex],0,bar,1,ma);
   return(ma[0]);
#endif   
//=====    
#ifdef __MQL4__  
//=====
   return(iMA(worksymbols[symbindex],MAs_Time_Frame,MA_Slow_Period,0,MAs_Method,MAs_Applied_Price,bar));
//=====
#endif 
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool HistoryRangeSignal(int symbindex,int type)
  {
//=====
   if(!Use_Day_Range_Indicator)return(true);
//=====

//=====
   if(symbindex<0 || symbindex>=ArraySize(worksymbols))return(false);
//=====

   double upperline=HistoryRangeUpperLine(symbindex,0);
   double lowerline=HistoryRangeLowerLine(symbindex,0);

   string SYMBOL=worksymbols[symbindex];

   double BID=SymbolInfoDouble(SYMBOL,SYMBOL_BID);

//=====
   ushort P=GetPoint(SYMBOL);
//=====
   double point=SymbolInfoDouble(SYMBOL,SYMBOL_POINT);
//=====
   if(MathAbs(lowerline-upperline)<Signal_Filter*P*point)
      return(false);
//=====
   if(DR_Trading_Mode==REVERSION || DR_Trading_Mode==BOTH)
     {
      //=====
      if(type==OP_BUY && (!DR_On_Cross_Only || iOpen(SYMBOL,PERIOD_D1,0)>lowerline) && BID<=lowerline && BID>=lowerline-10*P*point && lowerline>0 && MathAbs(lowerline-iOpen(SYMBOL,PERIOD_D1,0))>=Min_Day_Open_Distance*P*point)
         return(true);
      //=====
      if(type==OP_SELL && (!DR_On_Cross_Only || iOpen(SYMBOL,PERIOD_D1,0)<upperline) && BID>=upperline && BID<=upperline+10*P*point && upperline>0 && MathAbs(upperline-iOpen(SYMBOL,PERIOD_D1,0))>=Min_Day_Open_Distance*P*point)
         return(true);
      //=====
     }
   if(DR_Trading_Mode==BREAKOUT || DR_Trading_Mode==BOTH)
     {
      //=====
      if(type==OP_SELL && (!DR_On_Cross_Only || iOpen(SYMBOL,PERIOD_D1,0)>lowerline) && BID<lowerline-Min_BreakOut_Distance*P*point && lowerline>0 && BID>lowerline-(Min_BreakOut_Distance-10)*P*point && MathAbs(lowerline-iOpen(SYMBOL,PERIOD_D1,0))>=Min_Day_Open_Distance*P*point)
         return(true);
      //=====
      if(type==OP_BUY && (!DR_On_Cross_Only || iOpen(SYMBOL,PERIOD_D1,0)<upperline) && BID>upperline+Min_BreakOut_Distance*P*point && upperline>0 && BID>upperline+(Min_BreakOut_Distance-10)*P*point && MathAbs(upperline-iOpen(SYMBOL,PERIOD_D1,0))>=Min_Day_Open_Distance*P*point)
         return(true);
      //=====
     }

//=====
   return(false);
//=====
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+  
#ifdef __MQL5__
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int iHighest(const string SYMBOL,const ENUM_TIMEFRAMES tf,const int bars)
  {
   double values[];
   CopyHigh(SYMBOL,tf,0,bars,values);
   double highestvalue=0;
   int    highestindex=0;
   for(int i=0;i<ArraySize(values);i++)
     {
      if(values[i]>=highestvalue || highestvalue==0)
        {
         highestvalue=values[i];
         highestindex=i;
        }
     }
   return(highestindex);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int iLowest(const string SYMBOL,const ENUM_TIMEFRAMES tf,const int bars)
  {
   double values[];
   CopyLow(SYMBOL,tf,0,bars,values);
   double lowestvalue=0;
   int    lowestindex=0;
   for(int i=0;i<ArraySize(values);i++)
     {
      if(values[i]<=lowestvalue || lowestvalue==0)
        {
         lowestvalue=values[i];
         lowestindex=i;
        }
     }
   return(lowestindex);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//double iOpen(const string SYMBOL,const ENUM_TIMEFRAMES tf,const int bar)
//  {
//   double value[1]={0};
//   CopyOpen(SYMBOL,tf,bar,1,value);
//   return(value[0]);
//  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//double iHigh(const string SYMBOL,const ENUM_TIMEFRAMES tf,const int bar)
//  {
//   double value[1]={0};
//   CopyHigh(SYMBOL,tf,bar,1,value);
//   return(value[0]);
//  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//double iLow(const string SYMBOL,const ENUM_TIMEFRAMES tf,const int bar)
//  {
//   double value[1]={0};
//   CopyLow(SYMBOL,tf,bar,1,value);
//   return(value[0]);
//  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string OrderSymbol()
  {
   return(PositionGetString(POSITION_SYMBOL));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
datetime OrderOpenTime()
  {
   return((datetime)PositionGetInteger(POSITION_TIME));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OrderType()
  {
//=====
   if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY)return(OP_BUY);
   if(PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_SELL)return(OP_SELL);
//=====
   return(-1);
//=====
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double OrderLots()
  {
   return(PositionGetDouble(POSITION_VOLUME));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double OrderProfit()
  {
   return(PositionGetDouble(POSITION_PROFIT));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double OrderSwap()
  {
   return(PositionGetDouble(POSITION_SWAP));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double OrderCommission()
  {
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OrderTicket()
  {
   return((int)PositionGetInteger(POSITION_TICKET));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool OrderClose(const int ticket,const double volume,const double price,const int slippage,const color clr)
  {
//=====
   if(PositionSelectByTicket(ticket))
     {
      //=====
      MqlTradeRequest KillRequest={};
      MqlTradeResult KillResult={0};
      MqlTradeCheckResult KillCheck={0};
      //=====
      KillRequest.action=TRADE_ACTION_DEAL;
      KillRequest.position=ticket;
      KillRequest.magic=Magic;
      KillRequest.symbol=PositionGetString(POSITION_SYMBOL);
      KillRequest.price=PositionGetDouble(POSITION_PRICE_CURRENT);
      KillRequest.sl=0;
      KillRequest.tp=0;
      KillRequest.volume=volume;
      KillRequest.type=(ENUM_POSITION_TYPE)PositionGetInteger(POSITION_TYPE)==POSITION_TYPE_BUY?ORDER_TYPE_SELL:ORDER_TYPE_BUY;
      KillRequest.deviation=slippage;
      KillRequest.comment=PositionGetString(POSITION_COMMENT);
      KillRequest.type_filling=Order_Filling_Type;
      //=====
      bool check=OrderCheck(KillRequest,KillCheck);
      //=====
      if(check && KillCheck.retcode==0)
        {
         bool send=OrderSend(KillRequest,KillResult);

         if(KillResult.deal>0 || KillResult.order>0)
            return(true);
         else
            return(false);
        }
      else
         return(false);
     }
//=====
   return(false);
//=====
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OrderSend(const string SYMBOL,const int cmd,const double volume,const double price,const int slippage,const double sllevel,const double tplevel,const string comment,const int magic,const datetime expiration,const color arrow_color)
  {
   MqlTradeRequest OpenRequest={};
   MqlTradeResult OpenResult={0};
   MqlTradeCheckResult OpenCheck={0};
//=====
   OpenRequest.action=TRADE_ACTION_DEAL;
   OpenRequest.magic=magic;
   OpenRequest.symbol=SYMBOL;
   OpenRequest.price=price;
   OpenRequest.sl=sllevel;
   OpenRequest.tp=tplevel;
   OpenRequest.volume=volume;
   OpenRequest.type=cmd==OP_SELL?ORDER_TYPE_SELL:ORDER_TYPE_BUY;
   OpenRequest.deviation=slippage;
   OpenRequest.comment=comment;
   OpenRequest.type_filling=Order_Filling_Type;
//=====
   bool check=OrderCheck(OpenRequest,OpenCheck);
//=====
   if(check && OpenCheck.retcode==0)
     {
      bool send=OrderSend(OpenRequest,OpenResult);

      if(OpenResult.deal>0 || OpenResult.order>0)
         return((int)OpenResult.deal);
      else
         return(-1);
     }
   else
      return(-1);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double OrderClosePrice()
  {
   return(PositionGetDouble(POSITION_PRICE_CURRENT));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double OrderOpenPrice()
  {
   return(PositionGetDouble(POSITION_PRICE_OPEN));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool IsHedgingAccount(void)
  {
   return((ENUM_ACCOUNT_MARGIN_MODE)AccountInfoInteger(ACCOUNT_MARGIN_MODE)==ACCOUNT_MARGIN_MODE_RETAIL_HEDGING);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int OrderMagicNumber()
  {
   return((int)PositionGetInteger(POSITION_MAGIC));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//double iClose(const string SYMBOL,const ENUM_TIMEFRAMES tf,const int bar)
//  {
//   double value[1]={0};
//   CopyClose(SYMBOL,tf,bar,1,value);
//   return(value[0]);
//  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int TimeHour(const datetime time)
  {
//=====
   MqlDateTime timestruct;
   TimeToStruct(time,timestruct);
//=====
   return(timestruct.hour);
//=====
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int TimeDayOfWeek(const datetime time)
  {
//=====
   MqlDateTime timestruct;
   TimeToStruct(time,timestruct);
//=====
   return(timestruct.day_of_week);
//=====
  }
#endif   
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool MASignal(int symbindex,int type)
  {
//=====
   if(!Use_Moving_Averages)return(true);
//=====
   if(symbindex>=ArraySize(worksymbols) || symbindex<0)return(false);
//=====
   string SYMBOL=worksymbols[symbindex];
//=====
   double fast=FastMA(symbindex,0);
   double slow=SlowMA(symbindex,0);

   double BID=SymbolInfoDouble(SYMBOL,SYMBOL_BID);
//=====   
   if(type==OP_BUY && BID>=fast && fast>=slow)return(true);
//=====
   if(type==OP_SELL && BID<=fast && fast<=slow)return(true);
//=====

//=====
   return(false);
//=====
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
uchar GetPoint(const string SYMBOL)
  {
//=====
   if(SymbolInfoInteger(SYMBOL,SYMBOL_DIGITS)==5 || SymbolInfoInteger(SYMBOL,SYMBOL_DIGITS)==3)
      return(10);
//=====
   return(1);
//=====
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int GetIndex(const string SYMBOL)
  {
   for(int i=0;i<ArraySize(worksymbols);i++)
     {
      if(SYMBOL==worksymbols[i])
         return(i);
     }
//=====
   return(-1);
//=====
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool OurMagic(const int magic)
  {
//=====
   if(magic==Magic || Control_All_Positions)return(true);
//=====
   for(int i=0;i<ArraySize(magics);i++)
     {
      if(magic==magics[i])
         return(true);
     }
//=====
   return(false);
//=====
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void UpdateOrdersData(tradesinfo  &data[])
  {
//=====
   int openedsymbols=0;
   ArrayResize(data,0,100);
   int orders=0;
//=====
#ifdef __MQL4__ orders=OrdersTotal()-1; #endif
#ifdef __MQL5__ orders=PositionsTotal()-1; #endif
//=====
   if(orders>=0)
     {
      for(int i=orders;i>=0;i--)
        {
#ifdef __MQL4__ if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) #endif
#ifdef __MQL5__
         int posticket=(int)PositionGetTicket(i);
         if(!PositionSelectByTicket(posticket))
#endif
            continue;

         if(!OurMagic(OrderMagicNumber()))
            continue;

         bool symbolfound=false;

         for(int j=0;j<ArraySize(data);j++)
           {
            if(OrderSymbol()==data[j].symbol)
               symbolfound=true;
           }

         if(!symbolfound)
           {
            openedsymbols++;
            ArrayResize(data,openedsymbols,100);
            data[openedsymbols-1].symbol=OrderSymbol();
           }
        }

      //===== 
      int size=ArraySize(data);
      for(int i=0;i<size;i++)
        {
         int buys=CountOrders(data[i].symbol,OP_BUY);
         int sells=CountOrders(data[i].symbol,OP_SELL);

         if(buys>0 && sells>0)
           {
            openedsymbols++;
            ArrayResize(data,openedsymbols,100);
            data[openedsymbols-1].symbol=data[i].symbol;
            //=====
            data[openedsymbols-1].type=OP_BUY;
            data[i].type=OP_SELL;
           }
         //=====
         if(buys>0 && sells==0)data[i].type=OP_BUY;
         if(buys==0 && sells>0)data[i].type=OP_SELL;
         //=====
        }

      //===== 
      for(int i=0;i<ArraySize(data);i++)
        {
         //=====
         ushort P=GetPoint(data[i].symbol);
         //=====
         if(SymbolInfoDouble(data[i].symbol,SYMBOL_TRADE_TICK_SIZE)<=0 || SymbolInfoDouble(data[i].symbol,SYMBOL_POINT)<=0)
            continue;

         double pipprice=P*SymbolInfoDouble(data[i].symbol,SYMBOL_TRADE_TICK_VALUE)/(SymbolInfoDouble(data[i].symbol,SYMBOL_TRADE_TICK_SIZE)/SymbolInfoDouble(data[i].symbol,SYMBOL_POINT));

         data[i].orders=CountOrders(data[i].symbol,data[i].type);

         data[i].nextorderinsec=(int)(Min_Averaging_Time_Sec-((int)TimeCurrent()-LastOrderTime(data[i].symbol,data[i].type)));

         data[i].currentpnl=CountProfit(data[i].symbol,data[i].type)+GVGet("Closed PnL "+data[i].symbol);
         data[i].historypnl=CountClosedPnL(data[i].symbol,data[i].type,0,TimeCurrent()+60)-GVGet("Closed PnL "+data[i].symbol);
         data[i].netlots=CountVolume(data[i].symbol,data[i].type);

         if(data[i].netlots!=0)
            data[i].netpipstobe=data[i].currentpnl/(pipprice*MathAbs(data[i].netlots));
         else data[i].netpipstobe=100500;
        }
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Run()
  {
//=====
   bool trade=true;
//===== 
   if(!MQLInfoInteger(MQL_TESTER))
     {
      if(!TerminalInfoInteger(TERMINAL_TRADE_ALLOWED) || !MQLInfoInteger(MQL_TRADE_ALLOWED))
         trade=false;
     }
//===== Opening Initial Positions
   for(int j=0;j<ArraySize(worksymbols);j++)
     {
      string SYMBOL=worksymbols[j];

      //=====
      if(SymbolInfoDouble(SYMBOL,SYMBOL_POINT)<=0)continue;
      //=====
      ushort P=GetPoint(SYMBOL);
      //=====

      double atrmin=ATR_Minimum*P*SymbolInfoDouble(SYMBOL,SYMBOL_POINT);

      double triggerdist=MathMax(ATR(j,1)*ATR_Multiplier,atrmin);

      double highmark=0;
      double lowmark=0;

#ifdef __MQL4__
      int highestbarnumber=iHighest(SYMBOL,PERIOD_H1,MODE_HIGH,High_Low_Period,0);
      int lowestbarnumber=iLowest(SYMBOL,PERIOD_H1,MODE_LOW,High_Low_Period,0);
#endif

#ifdef __MQL5__
      int highestbarnumber=iHighest(SYMBOL,PERIOD_H1,High_Low_Period);
      int lowestbarnumber=iLowest(SYMBOL,PERIOD_H1,High_Low_Period);
#endif

      if(New_Mark_Distance<=0)
        {
         highmark=iHigh(SYMBOL,PERIOD_H1,highestbarnumber);
         lowmark=iLow(SYMBOL,PERIOD_H1,lowestbarnumber);
        }
      else
        {
         //=====
         double high=0;
         double low=0;
         double temphigh=0;
         double templow=0;
         //=====
         for(int i=0;i<=highestbarnumber;i++)
           {
            high=iHigh(SYMBOL,PERIOD_H1,i);
            low=iLow(SYMBOL,PERIOD_H1,i);
            if(high>temphigh || temphigh==0)temphigh=high;
            if(temphigh-low>=New_Mark_Distance*P*SymbolInfoDouble(SYMBOL,SYMBOL_POINT))
               break;
           }
         highmark=temphigh;
         //=====
         for(int i=0;i<=lowestbarnumber;i++)
           {
            high=iHigh(SYMBOL,PERIOD_H1,i);
            low=iLow(SYMBOL,PERIOD_H1,i);
            if(low<templow || templow==0)templow=low;
            if(high-templow>=New_Mark_Distance*P*SymbolInfoDouble(SYMBOL,SYMBOL_POINT))
               break;
           }
         lowmark=templow;
         //=====
        }

      //=====
      triggerpips[j]=triggerdist/(P*SymbolInfoDouble(SYMBOL,SYMBOL_POINT));

      pipstobuy[j]=(triggerdist-(highmark-iClose(SYMBOL,PERIOD_D1,0)))/(P*SymbolInfoDouble(SYMBOL,SYMBOL_POINT));
      pipstosell[j]=(triggerdist-(iClose(SYMBOL,PERIOD_D1,0)-lowmark))/(P*SymbolInfoDouble(SYMBOL,SYMBOL_POINT));

      //=====
      int buys=CountOrders(SYMBOL,OP_BUY);
      int sells=CountOrders(SYMBOL,OP_SELL);
      //=====

      //=====
      if(((!ATR_BreakOut_Mode && buys==0) || (ATR_BreakOut_Mode && sells==0)) && highmark-iClose(SYMBOL,PERIOD_D1,0)<triggerdist)GVSet("Can Enter "+(string)OP_BUY+SYMBOL,1);
      if(((!ATR_BreakOut_Mode && sells==0) || (ATR_BreakOut_Mode && buys==0)) && iClose(SYMBOL,PERIOD_D1,0)-lowmark<triggerdist)GVSet("Can Enter "+(string)OP_SELL+SYMBOL,1);
      //=====

      //=====
      if(buys+sells>0 && Use_ATR_Entry_Signal)continue;
      //=====

      if(GVGet("SOFTEXIT")<=0 && trade && TimeLocal()-inittime>=30 && GoodSpread(SYMBOL) && GoodTime())
        {

         if(
            Entry_Type!=BUYONLY && 
            HistoryRangeSignal(j,OP_SELL) && 
            MASignal(j,OP_SELL) && 
            (buys==0 || !Use_Moving_Averages) && 
            (
            (Use_ATR_Entry_Signal && ((!ATR_BreakOut_Mode && iClose(SYMBOL,PERIOD_D1,0)-lowmark>=triggerdist && (!Entry_On_Signal_Cross || GVGet("Can Enter "+(string)OP_SELL+SYMBOL)>0)) || (ATR_BreakOut_Mode && highmark-iClose(SYMBOL,PERIOD_D1,0)>=triggerdist && (!Entry_On_Signal_Cross || GVGet("Can Enter "+(string)OP_BUY+SYMBOL)>0)))) || 

            (!Use_ATR_Entry_Signal && sells==0)
            )
            )
           {
            Enter(OP_SELL,SYMBOL);
            GVDel("Can Enter "+(string)OP_SELL+SYMBOL);
            //=====
            Clean(OP_SELL,SYMBOL);
            //=====
           }

         if(
            Entry_Type!=SELLONLY && 
            HistoryRangeSignal(j,OP_BUY) && 
            MASignal(j,OP_BUY) && 
            (sells==0 || !Use_Moving_Averages) && 
            ((Use_ATR_Entry_Signal && ((!ATR_BreakOut_Mode && highmark-iClose(SYMBOL,PERIOD_D1,0)>=triggerdist && (!Entry_On_Signal_Cross || GVGet("Can Enter "+(string)OP_BUY+SYMBOL)>0)) || (ATR_BreakOut_Mode && iClose(SYMBOL,PERIOD_D1,0)-lowmark>=triggerdist && (!Entry_On_Signal_Cross || GVGet("Can Enter "+(string)OP_SELL+SYMBOL)>0)))) || 

            (!Use_ATR_Entry_Signal && buys==0))
            )
           {
            Enter(OP_BUY,SYMBOL);
            GVDel("Can Enter "+(string)OP_BUY+SYMBOL);
            //=====
            Clean(OP_BUY,SYMBOL);
            //=====
           }
        }
     }

//=====
   UpdateOrdersData(pairsdata);
//=====

//===== VISUAL PART
   UpdateDisplay();

//=====
   status="";

   if(!TerminalInfoInteger(TERMINAL_CONNECTED) && !MQLInfoInteger(MQL_TESTER))
     {
      status="!!! TERMINAL NOT CONNECTED !!!";
      BKG_Color=clrRed;
      return;
     }

//===== 
   if(!MQLInfoInteger(MQL_TESTER))
     {
      if(!TerminalInfoInteger(TERMINAL_TRADE_ALLOWED) || !MQLInfoInteger(MQL_TRADE_ALLOWED))
        {
         status="!!! AUTOTRADING NOT ALLOWED !!!";
         BKG_Color=clrRed;
         return;
        }
     }

//===== Cleaning Time Dependant Variables
   if(TimeHour(TimeCurrent())!=23)
      DeleteGlobalVariables("23 Closing");

   if(TimeDayOfWeek(TimeCurrent())!=5)
      DeleteGlobalVariables("FridayEntries");

//=====
   status=status+"ALL OK!";
   BKG_Color=clrBlue;

//===== DD Alerts
   if(TimeHour(TimeCurrent())!=Send_at_Hour_1)
      DeleteGlobalVariables("TimeAlert1 ");
   if(TimeHour(TimeCurrent())!=Send_at_Hour_2)
      DeleteGlobalVariables("TimeAlert2 ");

   for(int i=0;i<ArraySize(pairsdata);i++)
     {
      string symb=pairsdata[i].symbol;
      int    type=pairsdata[i].type;


      double currentDD=0;

      if(pairsdata[i].orders>0)
        {
         currentDD=pairsdata[i].currentpnl;

         string subject=Portfolio_Comment+" | DD Alert";
         if(MathAbs(currentDD)>=Critical_DD)
            subject=subject+" !!! CRITICAL !!!";

         string message=Portfolio_Comment+" | TOTAL DD is = $"+DoubleToString(currentDD,1)+" ("+DoubleToString(100*MathAbs(currentDD)/AccountInfoDouble(ACCOUNT_BALANCE),1)+"%) Lot: "+
                        DoubleToString(pairsdata[i].netlots,2);

         //=====
         if(TimeHour(TimeCurrent())==Send_at_Hour_1 && GVGet("TimeAlert1 "+(string)type+symb)==0)
           {
            Informer(message,symb,subject);
            GVSet("TimeAlert1 "+(string)type+symb,1);
           }

         if(TimeHour(TimeCurrent())==Send_at_Hour_2 && GVGet("TimeAlert2 "+(string)type+symb)==0)
           {
            Informer(message,symb,subject);
            GVSet("TimeAlert2 "+(string)type+symb,1);
           }

         //=====

         double dd=0;
         for(int j=0;j<50;j++)
           {
            dd=DD_Threshold_Start+j*DD_Threshold_Step;
            if(MathAbs(currentDD)>=dd && GVGet("DDAlert # "+(string)type+symb+(string)j)==0)
              {
               Informer(message,symb,subject);
               GVSet("DDAlert # "+(string)type+symb+(string)j,1);
              }
           }
        }
     }

//=====    
   for(int i=0;i<ArraySize(pairsdata);i++)
     {
      string symb=pairsdata[i].symbol;
      int    type=pairsdata[i].type;

      if(GVGet("Kill "+(string)type+symb)!=0)
        {
         //===== Kill On GVs
         while(CountOrders(symb,type)>0)
            CloseOrders(symb,type,"Kill Now");

         //=====
         Clean(type,symb);
         //=====
         GVSet("Kill "+(string)type+symb,0);
         //=====
         continue;
         //=====
        }

      //===== Close at Opposite Signal
      if(Close_At_Opposite && Use_Moving_Averages)
        {
         if(pairsdata[i].orders>0 && MASignal(GetIndex(symb),type==OP_BUY?OP_SELL:OP_BUY))
           {
            //=====
            while(CountOrders(symb,type)>0)
               CloseOrders(symb,type,"Close at Opposite signal");
            //=====

            //=====
            Clean(type,symb);
            //=====

            if(Reopen_Basket)
              {
               Enter(type==OP_BUY?OP_SELL:OP_BUY,symb,pairsdata[i].netlots);
               double closedpnl=GVGet("Closed PnL "+symb);
               GVSet("Closed PnL "+symb,closedpnl+pairsdata[i].currentpnl);
              }

            //=====
            continue;
            //=====
           }
        }

      if(DR_Close_On_Opposite && Use_Day_Range_Indicator)
        {
         if(pairsdata[i].orders>0 && HistoryRangeSignal(GetIndex(symb),type==OP_BUY?OP_SELL:OP_BUY))
           {
            //=====
            while(CountOrders(symb,type)>0)
               CloseOrders(symb,type,"Close at Opposite signal DR");
            //=====

            //=====
            Clean(type,symb);
            //=====

            //=====
            continue;
            //=====
           }
        }

      //===== Take Profit
      if(Take_Profit!=0 && (!Disable_If_Trailed || GVGet("TSL "+(string)type+symb)==0))
        {
         if(pairsdata[i].orders>0 && pairsdata[i].netpipstobe>=Take_Profit && (!Trailing_Stop || pairsdata[i].netlots<Trail_Start_Lot))
           {
            while(CountOrders(symb,type)>0)
               CloseOrders(symb,type,"Take Profit");

            //=====
            GVDel("Closed PnL "+symb);
            Clean(type,symb);

            //=====
            continue;
           }
        }

      //===== Trailing Stop
      if(Trailing_Stop)
        {
         if(pairsdata[i].netlots>=Trail_Start_Lot)
           {
            if(GVGet("TSL "+(string)type+symb)!=0 && pairsdata[i].netpipstobe<=GVGet("TSL "+(string)type+symb))
              {
               while(CountOrders(symb,type)>0)
                  CloseOrders(symb,type,"Basket Trailing Stop");

               //=====
               GVDel("Closed PnL "+symb);
               Clean(type,symb);

               //=====
               continue;
              }

            if(pairsdata[i].netpipstobe>=Trailing_Stop_Start_p && pairsdata[i].netlots>=Trail_Start_Lot)
              {
               if(pairsdata[i].netpipstobe-Trailing_Stop_Distance_p>GVGet("TSL "+(string)type+symb) || GVGet("TSL "+(string)type+symb)==0)
                 {
                  if(GVGet("TSL "+(string)type+symb)==0)
                     DeleteObjects();

                  //=====
                  double tslpips=pairsdata[i].netpipstobe-Trailing_Stop_Distance_p;
                  if(Trailing_Stop_Max_Pips>0)
                     tslpips=MathMin(tslpips,Trailing_Stop_Max_Pips);
                  //=====   
                  GVSet("TSL "+(string)type+symb,tslpips);
                  //=====
                 }
              }
           }
         else
            GVDel("TSL "+(string)type+symb);
        }

      //=====
      bool noaction=false;
      if(GVGet("NoAction "+(string)type+symb)>0)noaction=true;

      //===== Trending
      if(Allow_Trending && GVGet("Averaging "+(string)type+symb)==0 && pairsdata[i].orders>0 && pairsdata[i].orders<Max_Orders_Pyramid)
        {
         double prevorderprice=0;
         double prevorderlots=0;

         LastOrderData(symb,type,prevorderprice,prevorderlots);

         //=====
         ushort P=GetPoint(symb);
         //=====

         if(prevorderprice>0 && 
            ((type==OP_BUY && SymbolInfoDouble(symb,SYMBOL_ASK)-prevorderprice>=Orders_Step*P*SymbolInfoDouble(symb,SYMBOL_POINT)) || 
            (type==OP_SELL && prevorderprice-SymbolInfoDouble(symb,SYMBOL_BID)>=Orders_Step*P*SymbolInfoDouble(symb,SYMBOL_POINT)))
            )
           {
            if(Split_Lots_When_Limit)
              {
               double shouldopen=prevorderlots*Prev_Lot_Multiplier;
               double opened=0;
               while(opened<shouldopen)
                  opened+=MarketOrder(symb,type,shouldopen-opened,"Trending");
              }
            else
               MarketOrder(symb,type,prevorderlots*Prev_Lot_Multiplier,"Trending");
            //=====
            GVSet("Trending "+(string)type+symb,1);
            //=====
            continue;
            //=====
           }
        }

      //===== Averaging   
      if(Keep_Distance_to_BE>0 && GVGet("Trending "+(string)type+symb)==0 && !noaction)
        {
         //=====
         int index=GetIndex(symb);if(index<0)continue;
         //=====
         double value=pipstobuy[index];if(type==OP_SELL)value=pipstosell[index];
         //=====
         if(pairsdata[i].orders>0 && DRAveragingFilter(index,type,pairsdata[i].netlots) && (!Use_Averaging_By_ATR || value<=ATR_Averaging_Value) && pairsdata[i].netpipstobe<=-Keep_Distance_to_BE && GoodSpread(symb) && pairsdata[i].orders<Max_Orders && TimeCurrent()-LastOrderTime(symb,type)>=Min_Averaging_Time_Sec && GoodDistance(symb,type))
           {
            double nextlot=0;

            nextlot=GetLot(MathAbs(pairsdata[i].netpipstobe),MathAbs(pairsdata[i].netlots));

            double maxlot=Max_Net_Lot;

            if(MathAbs(pairsdata[i].netlots)+nextlot>=maxlot)
               nextlot=maxlot-MathAbs(pairsdata[i].netlots);

            if(nextlot>=SymbolInfoDouble(pairsdata[i].symbol,SYMBOL_VOLUME_MIN))
              {
               if(Split_Lots_When_Limit)
                 {
                  double shouldopen=nextlot;
                  double opened=0;
                  while(opened<shouldopen)
                     opened+=MarketOrder(symb,type,shouldopen-opened,"Averaging");
                 }
               else
                  MarketOrder(symb,type,nextlot,"Averaging");
               //=====
               GVSet("Averaging "+(string)type+symb,1);
               //=====
               continue;
              }
           }
        }

      //===== Min Profit When Pyramid
      if(GVGet("Trending "+(string)type+symb)>0)
        {
         if(pairsdata[i].orders>0 && pairsdata[i].currentpnl<=Min_Profit_if_Pyramid && Min_Profit_if_Pyramid>0)
           {
            while(CountOrders(symb,type)>0)
               CloseOrders(symb,type,"Min Profit Pyramid");

            //=====
            GVDel("Closed PnL "+symb);
            Clean(type,symb);

            //=====
            continue;
            //=====
           }
        }

      //===== Stop Loss
      if(Stop_Loss>0)
        {
         if(pairsdata[i].orders>0 && (!Disable_For_Basket || pairsdata[i].orders==1) && pairsdata[i].currentpnl<=-Stop_Loss)
           {
            while(CountOrders(symb,type)>0)
               CloseOrders(symb,type,"Stop Loss");

            //=====
            GVDel("Closed PnL "+symb);
            Clean(type,symb);

            //=====
            continue;
           }
        }

      //===== If NO ACTION mode, we do not process the operations below.
      if(GVGet("NoAction "+(string)type+symb)>0)
         continue;

      //=====
      if(Close_At_23)
        {
         if(pairsdata[i].orders>0 && TimeHour(TimeCurrent())==23 && GVGet("23 Closing "+(string)type+symb)==0)
           {

            while(CountOrders(symb,type)>0)
               CloseOrders(symb,type,"Close at 23:00");

            //=====
            GVSet("23 Closing "+(string)type+symb,1);

            //=====
            Clean(type,symb);

            //=====
            continue;
           }
        }

      //===== Closing at Max Lot
      if(Close_At_Max_Lot>0 && Max_Close_Times>0)
        {
         int closedtimes=(int)GVGet("ClosedTimes "+(string)type+symb);
         if(closedtimes<Max_Close_Times && pairsdata[i].netlots>=Max_Net_Lot)
           {
            if(ClosePercents(type,symb))
               GVSet("ClosedTimes "+(string)type+symb,closedtimes+1);

            //=====
            continue;
           }
        }

      //===== Max Loss at Reverse
      if(Start_Lot_To_Apply>0)
        {
         if(pairsdata[i].orders>0 && pairsdata[i].netpipstobe>=-Max_Loss_At_Reverse_Pips && pairsdata[i].netlots>=Start_Lot_To_Apply)
           {

            while(CountOrders(symb,type)>0)
               CloseOrders(symb,type,"Max Loss at Reverse");

            //=====
            Clean(type,symb);

            //=====
            continue;
           }
        }
     }
//=====
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool GoodTimeFirst()
  {
//=====
   if(!Use_Time_Zone_First)return(true);
//=====   

   if(
      (StringToTime(Time_Zone_First_Start)<StringToTime(Time_Zone_First_End) && TimeCurrent()>StringToTime(Time_Zone_First_Start) && TimeCurrent()<StringToTime(Time_Zone_First_End)) || 
      (StringToTime(Time_Zone_First_Start)>StringToTime(Time_Zone_First_End) && (TimeCurrent()>StringToTime(Time_Zone_First_Start) || TimeCurrent()<StringToTime(Time_Zone_First_End)))
      )
      return(true);

//=====  

//=====     
   return(false);
//=====   
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool GoodTime()
  {
//=====
   if(!Use_Time_Zone_1 && !Use_Time_Zone_2)return(true);
//=====   
   if(Use_Time_Zone_1)
     {
      if(
         (StringToTime(Time_Zone_1_Start)<StringToTime(Time_Zone_1_End) && TimeCurrent()>StringToTime(Time_Zone_1_Start) && TimeCurrent()<StringToTime(Time_Zone_1_End)) || 
         (StringToTime(Time_Zone_1_Start)>StringToTime(Time_Zone_1_End) && (TimeCurrent()>StringToTime(Time_Zone_1_Start) || TimeCurrent()<StringToTime(Time_Zone_1_End)))
         )
         return(true);
     }
//=====  
   if(Use_Time_Zone_2)
     {
      if(
         (StringToTime(Time_Zone_2_Start)<StringToTime(Time_Zone_2_End) && TimeCurrent()>StringToTime(Time_Zone_2_Start) && TimeCurrent()<StringToTime(Time_Zone_2_End)) || 
         (StringToTime(Time_Zone_2_Start)>StringToTime(Time_Zone_2_End) && (TimeCurrent()>StringToTime(Time_Zone_2_Start) || TimeCurrent()<StringToTime(Time_Zone_2_End)))
         )
         return(true);
     }
//=====     
   return(false);
//=====   
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool NewBar(string SYMBOL,ENUM_TIMEFRAMES TIMEFRAME)
  {
   datetime time[1];

   int copytime=CopyTime(SYMBOL,TIMEFRAME,0,1,time);

   if(copytime<1)return(false);


   if(time[0]!=GVGet("Static_LastBar"))
     {
      GVSet("Static_LastBar",time[0]);
      return(true);
     }
   return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double Enter(int type,string symb,double lots=0)
  {
   double opened=-1;
   int tries=0;

   int entriesonfriday=(int)GVGet("FridayEntries "+(string)type+symb);
   int entriesdaily=(int)GVGet("DailyEntries "+(string)type+symb);

   if((Max_Entries_Daily==0 || entriesdaily<Max_Entries_Daily) && (TimeDayOfWeek(TimeCurrent())!=5 || entriesonfriday<Max_Entries_On_Friday))
     {
      while(opened<0 && tries<=100)
        {
         opened=MarketOrder(symb,type,lots==0?FirstLot(symb):lots,"Entry");
         tries++;
        }

      if(opened>0)
        {
         //=====
         GVDel("REOPEN #"+(string)type+symb);
         //=====
         if(TimeDayOfWeek(TimeCurrent())==5)GVSet("FridayEntries "+(string)type+symb,entriesonfriday+1);
         //=====
         GVSet("DailyEntries "+(string)type+symb,entriesdaily+1);
         //=====
        }
     }
   else
      GVSet("REOPEN #"+(string)type+symb,1);

//=====
   return(opened);
//=====   
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Clean(int type,string symb)
  {
   GVDel("Trending "+(string)type+symb);
   GVDel("Averaging "+(string)type+symb);
   GVDel("TSL "+(string)type+symb);
   GVDel("ClosedTimes "+(string)type+symb);

   for(int j=0;j<50;j++)
      GVDel("DDAlert # "+(string)type+symb+(string)j);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool ClosePercents(int type,string symb)
  {
   double currentlots=CountVolume(symb,type);

   double shouldremain=currentlots-(currentlots*Close_At_Max_Lot/100);

   while(CountVolume(symb,type)>shouldremain)
     {
      double delta=CountVolume(symb,type)-shouldremain;

      KillVolume(symb,type,delta);
     }

   if(CountVolume(symb,type)<=shouldremain)
      return(true);

   return(false);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double GetTrendMoveReal(double startlot,double maxlot)
  {
   double trend=0;
   double lotsopened=0;
   double avprice=0;
   double firstorder=0;
   double lastorder=0;
   double nextlot=0;
   int orders=0;

//=====
   ushort P=GetPoint(_Symbol);
//=====

   double closedist=Keep_Distance_to_BE;

//===== Getting Tick Info
   MqlTick tick={0};
   if(!SymbolInfoTick(_Symbol,tick) || tick.ask<=0 || tick.bid<=0)
      return(0);

   double ASK=tick.ask;
   double BID=tick.bid;

   while(lotsopened<=maxlot)
     {
      if(lotsopened==0)
        {
         lotsopened=startlot;
         avprice=BID;
         firstorder=BID;
         lastorder=BID;
         orders++;
        }
      else
        {
         lastorder=avprice+closedist*P*_Point;
         double averageneeded=lastorder-closedist*P*_Point;

         if(lastorder-averageneeded==0)
            return(0);
         nextlot=lotsopened*MathAbs(averageneeded-avprice)/MathAbs(lastorder-averageneeded);

         nextlot=CheckLot(_Symbol,nextlot);

         avprice=(avprice*lotsopened/(lotsopened+nextlot))+(lastorder*nextlot/(lotsopened+nextlot));
         lotsopened+=nextlot;
         orders++;
        }
     }

   return(MathAbs(lastorder-firstorder)/(P*_Point));
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void KillVolume(string SYMBOL,int type,double volume)
  {
//=====
   int orders=0;
//=====
#ifdef __MQL4__ orders=OrdersTotal()-1; #endif
#ifdef __MQL5__ orders=PositionsTotal()-1; #endif
//=====
   int ticket=-1;
   double maxprofit=0;

   for(int i=orders; i>=0; i--)
     {
#ifdef __MQL4__ if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) #endif
#ifdef __MQL5__
      ticket=(int)PositionGetTicket(i);
      if(!PositionSelectByTicket(ticket))
#endif
         continue;

      if(OrderSymbol()==SYMBOL && OrderType()==type && OurMagic(OrderMagicNumber()))
        {
         if(OrderLots()<=MathMax(volume,SymbolInfoDouble(SYMBOL,SYMBOL_VOLUME_MIN)) && (OrderProfit()>maxprofit || maxprofit==0))
           {
            maxprofit=OrderProfit();
            ticket=OrderTicket();
           }
        }
     }

//=====
   maxprofit=0;
   if(ticket<0)
     {
      for(int i=orders; i>=0; i--)
        {
#ifdef __MQL4__ if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) #endif
#ifdef __MQL5__
         ticket=(int)PositionGetTicket(i);
         if(!PositionSelectByTicket(ticket))
#endif
            continue;

         if(OrderSymbol()==SYMBOL && OrderType()==type && OurMagic(OrderMagicNumber()))
           {
            if(OrderProfit()>maxprofit || maxprofit==0)
              {
               maxprofit=OrderProfit();
               ticket=OrderTicket();
              }
           }
        }
     }

//====
#ifdef __MQL4__ if(OrderSelect(ticket,SELECT_BY_TICKET))#endif
#ifdef __MQL5__ if(PositionSelectByTicket(ticket))#endif
     {
      //=====
      ushort P=GetPoint(SYMBOL);
      //=====

      //=====
      bool Closing=OrderClose(OrderTicket(),MathMin(OrderLots(),CheckLot(SYMBOL,volume)),OrderClosePrice(),int(Slippage*P),clrNONE);

      if(!Closing)
         Informer("ERROR: "+GetTradeErrorDescription(GetLastError()),SYMBOL);
      else
         Informer("Order successfully closed. Close At Max Lot",SYMBOL);
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnChartEvent(const int id,const long &lparam,const double &dparam,const string &sparam)
  {
   if(id==CHARTEVENT_OBJECT_CLICK)
     {
      if(StringFind(sparam,"SOFTEXIT")>0)
        {
         if(GVGet("SOFTEXIT")<=0)GVSet("SOFTEXIT",1);
         else
            GVSet("SOFTEXIT",-1);
        }

      //=====

      if(StringFind(sparam,"KillNow_")>0)
        {
         string typeandpair=StringSubstr(sparam,StringFind(sparam,"#")+1);

         int type=(int)StringToInteger(StringSubstr(typeandpair,0,1));
         string symb=StringSubstr(typeandpair,1);

         while(CountOrders(symb,type)>0 && TerminalInfoInteger(TERMINAL_CONNECTED) && TerminalInfoInteger(TERMINAL_TRADE_ALLOWED) && MQLInfoInteger(MQL_TRADE_ALLOWED))
            CloseOrders(symb,type,"Kill Now");
         
         //=====
         GVDel("Closed PnL "+symb);

         //=====
         Clean(type,symb);

         //=====
         return;
        }

      if(StringFind(sparam,"NoAction_")>0)
        {
         string typeandpair=StringSubstr(sparam,StringFind(sparam,"#")+1);

         int type=(int)StringToInteger(StringSubstr(typeandpair,0,1));
         string pair=StringSubstr(typeandpair,1);

         if(GVGet("NoAction "+(string)type+pair)==0)
            GVSet("NoAction "+(string)type+pair,1);
         else
            GVDel("NoAction "+(string)type+pair);

         return;
        }
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double GetLot(double currentpipstobe,double currentlot)
  {
   double nextlot=0;

   nextlot=currentlot*MathAbs(currentpipstobe-Keep_Distance_to_BE)/MathAbs(Keep_Distance_to_BE);

   return(nextlot);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
   if(MQLInfoInteger(MQL_TESTER))
      DeleteGlobalVariables();
   else
      DeleteObjects();

//=====
   EventKillTimer();

//=====
   Comment("");

//=====
   Informer("EA Stopped. "+DeinitReason(reason),_Symbol);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool GoodSpread(string SYMBOL)
  {
   double point=SymbolInfoDouble(SYMBOL,SYMBOL_POINT);
   int digits=(int)SymbolInfoInteger(SYMBOL,SYMBOL_DIGITS);

   MqlTick lasttick={0};
   if(!SymbolInfoTick(SYMBOL,lasttick))
      return(false);
   double ask=lasttick.ask;
   double bid=lasttick.bid;

//=====
   ushort P=GetPoint(SYMBOL);
//=====

//===== Max Spread Filter
   double spread=(ask-bid)/(P*point);

   for(int i=0;i<customspread;i++)
     {
      if(StringFind(SYMBOL,SpreadSymbols[i],0)>=0)
        {
         if(spread>=SpreadMax[i])
            return(false);
         break;
        }
     }

   return(true);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double FirstLot(string SYMBOL)
  {
   for(int i=0;i<customlot;i++)
     {
      if(StringFind(SYMBOL,LotSymbols[i],0)>=0)
         return(LotValue[i]);
     }

//=====
   return(Default_Lot);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CreateHLine(string name,string tooltip,double price,color Color,ENUM_LINE_STYLE style,int width,bool ray,long chartid,int subwindow)
  {
   string NAME=prefix+name;

   if(ObjectFind(chartid,NAME)!=subwindow)
      ObjectCreate(chartid,NAME,OBJ_HLINE,subwindow,0,price);
   ObjectSetString(chartid,NAME,OBJPROP_TOOLTIP,tooltip);
   ObjectSetInteger(chartid,NAME,OBJPROP_COLOR,Color);
   ObjectSetInteger(chartid,NAME,OBJPROP_STYLE,style);
   ObjectSetInteger(chartid,NAME,OBJPROP_WIDTH,width);
   ObjectSetInteger(chartid,NAME,OBJPROP_BACK,true);
   ObjectSetInteger(chartid,NAME,OBJPROP_RAY_RIGHT,ray);
   ObjectMove(chartid,NAME,0,0,price);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void UpdateDisplay()
  {
//=====
   if(MQLInfoInteger(MQL_TESTER) && !MQLInfoInteger(MQL_VISUAL_MODE))return;
   
//===== Lines
   if(MQLInfoInteger(MQL_TESTER))
     {
      CreateHLine("High","High",iHigh(_Symbol,PERIOD_D1,0),clrBlue,STYLE_SOLID,2,true,0,0);
      CreateHLine("Low","Low",iLow(_Symbol,PERIOD_D1,0),clrGreen,STYLE_SOLID,2,true,0,0);
     }
//=====
   int static orders;
#ifdef __MQL5__
   if(orders!=PositionsTotal())
      DeleteObjects();
   orders=OrdersTotal();

#endif
#ifdef __MQL4__
   int static historyorders;
   if(orders!=OrdersTotal() || historyorders!=OrdersHistoryTotal())
      DeleteObjects();
   orders=OrdersTotal();
   historyorders=OrdersHistoryTotal();
#endif

//=====

//CreateImageLabel("BKG","",GVGet("SOFTEXIT")<=0?BKG_Color:clrOrange,1400,1000,0,0,Corner,ANCHOR_LEFT,0,0);

//=====
   int y=60;
   int x=400;

//===== SOFT EXIT BUTTON
   CreateImageLabel("SOFTEXIT LBL","SOFT EXIT",GVGet("SOFTEXIT")<=0?clrGreen:clrRed,20,110,x,y-10,CORNER_LEFT_UPPER,ANCHOR_CENTER,0,0);
   CreateTextLabel("SOFTEXIT TXT","SOFT EXIT"+(GVGet("SOFTEXIT")<=0?" OFF":" ON"),"",Font_Name,Font_Size,Text_Color,x+OffSet,y,Corner,Anchor,0,0);x+=dx;

//=====
   y=45;
   x=0;
//=== Status
   CreateTextLabel("Status","PM EA | "+status+" | "+TimeToString(TimeCurrent(),TIME_DATE|TIME_MINUTES),"",Font_Name,Font_Size,Text_Color,x+OffSet,y,Corner,Anchor,0,0);
   y+=dy;
   CreateTextLabel("Settings","Take Profit: "+(Take_Profit==0?"OFF":DoubleToString(Take_Profit,2))+" | Stop Loss: "+(Stop_Loss==0?"OFF":DoubleToString(Stop_Loss,2))+"  |  Keep Distance: "+(Keep_Distance_to_BE==0?"OFF":DoubleToString(Keep_Distance_to_BE,1)),"",Font_Name,Font_Size,Text_Color,x+OffSet,y,Corner,Anchor,0,0);
   y+=dy;

   CreateTextLabel("TMove","Trend Move (aprox.): "+DoubleToString(survivedmove,1),"",Font_Name,Font_Size,Text_Color,x+OffSet,y,Corner,Anchor,0,0);
   y+=dy;

   int tempcnt=0;

   int    indexesarray[];
   double tempdoublearray[];

   ArrayResize(tempdoublearray,ArraySize(worksymbols));
   ArrayResize(indexesarray,ArraySize(worksymbols));
   for(tempcnt=0;tempcnt<ArraySize(worksymbols);tempcnt++){indexesarray[tempcnt]=tempcnt;tempdoublearray[tempcnt]=MathMin(pipstobuy[tempcnt],pipstosell[tempcnt]);}
   SortDoubleArray(-1,indexesarray,tempdoublearray);

   tempcnt=0;

   int showinline=2;
   string atrs="";

   for(int i=0;i<ArraySize(worksymbols);i++)
     {
      int pos=indexesarray[i];
      tempcnt++;
      atrs=atrs+worksymbols[pos]+": "+DoubleToString(triggerpips[pos],1)+"("+DoubleToString(pipstobuy[pos],1)+"/"+DoubleToString(pipstosell[pos],1)+") | ";

      if(tempcnt==showinline || i==ArraySize(worksymbols)-1)
        {
         CreateTextLabel("ATRs"+(string)i,"ATR: "+atrs,"",Font_Name,Font_Size,Text_Color,x+OffSet,y,Corner,Anchor,0,0);
         y+=dy;

         atrs="";
         tempcnt=0;
        }
     }

   y+=dy;

//===== Create Header
   CreateTextLabel("Pair #Header","Pair","",Font_Name,Font_Size,Text_Color,x+OffSet,y,Corner,Anchor,0,0);x+=dx;
   CreateTextLabel("Pair #Type","Type","",Font_Name,Font_Size,Text_Color,x+OffSet,y,Corner,Anchor,0,0);x+=dx;
   CreateTextLabel("NextOrder #Header","Next Order","",Font_Name,Font_Size,Text_Color,x+OffSet,y,Corner,Anchor,0,0);x+=dx;
   CreateTextLabel("Orders #Header","Orders","",Font_Name,Font_Size,Text_Color,x+OffSet,y,Corner,Anchor,0,0);x+=dx;
   CreateTextLabel("Lots #Header","Lots","",Font_Name,Font_Size,Text_Color,x+OffSet,y,Corner,Anchor,0,0);x+=dx;
   CreateTextLabel("PipsToBE #Header","Pips to BE","",Font_Name,Font_Size,Text_Color,x+OffSet,y,Corner,Anchor,0,0);x+=dx;
   CreateTextLabel("CurrentPnL #Header","Current PnL,$","",Font_Name,Font_Size,Text_Color,x+OffSet,y,Corner,Anchor,0,0);x+=dx;
   CreateTextLabel("HistoryPnL #Header","History PnL,$","",Font_Name,Font_Size,Text_Color,x+OffSet,y,Corner,Anchor,0,0);x+=dx;
   CreateTextLabel("KillNow #Header","Kill Now","",Font_Name,Font_Size,Text_Color,x+OffSet,y,Corner,Anchor,0,0);x+=dx;
   CreateTextLabel("NoAction #Header","No Action","",Font_Name,Font_Size,Text_Color,x+OffSet,y,Corner,Anchor,0,0);x+=dx;
   x=0;
   y+=dy;

//=====
   if(
      #ifdef __MQL4__ OrdersTotal()==0 #endif
      #ifdef __MQL5__ PositionsTotal()==0 #endif
      )
      return;

//===== SORT DATA

   ArrayResize(tempdoublearray,ArraySize(pairsdata));
   ArrayResize(indexesarray,ArraySize(pairsdata));

   for(int cnt=0;cnt<ArraySize(pairsdata);cnt++)
     {
      indexesarray[cnt]=cnt;
      tempdoublearray[cnt]=pairsdata[cnt].netlots;
     }

   SortDoubleArray(1,indexesarray,tempdoublearray);

//===== Build Rows
   for(int j=0;j<ArraySize(pairsdata);j++)
     {
      int i=indexesarray[j];
      string symb=pairsdata[i].symbol;
      int    type=pairsdata[i].type;

      CreateTextLabel("Pair #"+(string)type+symb,pairsdata[i].symbol,"",Font_Name,Font_Size,Text_Color,x+OffSet,y,Corner,Anchor,0,0);x+=dx;
      CreateTextLabel("Type #"+(string)type+symb,(pairsdata[i].type==OP_BUY?"BUY":"SELL"),"",Font_Name,Font_Size,Text_Color,x+OffSet,y,Corner,Anchor,0,0);x+=dx;

      string nextorder=ConvertToTime(pairsdata[i].nextorderinsec);

      CreateTextLabel("NextOrder #"+(string)type+symb,nextorder,"",Font_Name,Font_Size,Text_Color,x+OffSet,y,Corner,Anchor,0,0);x+=dx;

      CreateTextLabel("Orders #"+(string)type+symb,       (string)pairsdata[i].orders                     ,"",Font_Name,Font_Size,Text_Color,x+OffSet,y,Corner,Anchor,0,0);x+=dx;
      CreateTextLabel("Lots #"+(string)type+symb,         DoubleToString(pairsdata[i].netlots,2)          ,"",Font_Name,Font_Size,Text_Color,x+OffSet,y,Corner,Anchor,0,0);x+=dx;
      CreateTextLabel("PipsToBE #"+(string)type+symb,     DoubleToString(pairsdata[i].netpipstobe,1)      ,"",Font_Name,Font_Size,Text_Color,x+OffSet,y,Corner,Anchor,0,0);x+=dx;

      color textcolor=Text_Color;
      string tsladdtext="";
      if(GVGet("TSL "+(string)type+symb)!=0)
        {
         textcolor=clrYellow;
         tsladdtext=" ("+DoubleToString(pairsdata[i].netpipstobe-GVGet("TSL "+(string)type+symb),1)+")";
        }

      if(textcolor!=Text_Color)
         CreateImageLabel("TSL Active #"+(string)type+symb,"TSL Active",clrBlack,20,110,x,y-10,CORNER_LEFT_UPPER,ANCHOR_LEFT,0,0);
      CreateTextLabel("CurrentPnL #"+(string)type+symb,DoubleToString(pairsdata[i].currentpnl,2)+tsladdtext,"",Font_Name,Font_Size,textcolor,x+OffSet,y,Corner,Anchor,0,0);x+=dx;

      CreateTextLabel("HistoryPnL #"+(string)type+symb,DoubleToString(pairsdata[i].historypnl,2),"",Font_Name,Font_Size,Text_Color,x+OffSet,y,Corner,Anchor,0,0);x+=dx;

      CreateImageLabel("KillNow_ button #"+(string)type+symb,"KILL "+symb,clrRed,20,80,x,y-10,CORNER_LEFT_UPPER,ANCHOR_LEFT,0,0);
      CreateTextLabel("KillNow_ #"+(string)type+symb,"K "+symb,"",Font_Name,Font_Size,Text_Color,x+OffSet,y,Corner,Anchor,0,0);x+=dx;

      CreateImageLabel("NoAction_ button #"+(string)type+symb,"NO ACTION "+symb,GVGet("NoAction "+(string)type+symb)==0?clrRed:clrGreen,20,110,x,y-10,CORNER_LEFT_UPPER,ANCHOR_LEFT,0,0);
      CreateTextLabel("NoAction_ #"+(string)type+symb,"N/A "+symb,"",Font_Name,Font_Size,Text_Color,x+OffSet,y,Corner,Anchor,0,0);x+=dx;

      x=0;
      y+=dy;
     }

//=====
   ChartRedraw(0);
//=====         
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string ConvertToTime(int secondsnumber)
  {
   int seconds=MathAbs(secondsnumber);

   int hours=seconds/3600;
   int minutes=(seconds-hours*3600)/60;
   int sec=seconds-hours*3600-minutes*60;

   string result="";
   if(secondsnumber<0)result="-";
   result=result+(string)hours+":"+(string)minutes+":"+(string)sec;

   return(result);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void SortDoubleArray(int direction,int &indexes[],double &tosort[])
  {
   if(direction==0)
      return;

   int     tempindex=0;
   double  tempdatavalue=0;

   int size=ArraySize(tosort);

   for(int i=0;i<size;i++)
     {
      for(int j=0;j<size;j++)
        {
         if((tosort[j]<=tosort[i] && direction>0) || (tosort[j]>=tosort[i] && direction<0))
           {
            tempdatavalue=tosort[j];
            tempindex=indexes[j];
            tosort[j]=tosort[i];
            indexes[j]=indexes[i];
            tosort[i]=tempdatavalue;
            indexes[i]=tempindex;
           }
        }
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void Informer(string MESSAGE,string SYMBOL,string subject="")
  {
   string message=TimeToString(TimeCurrent(),TIME_DATE|TIME_MINUTES|TIME_SECONDS)+" | "+TimeToString(TimeLocal(),TIME_DATE|TIME_MINUTES|TIME_SECONDS)+" => "+SYMBOL+" "+MESSAGE;

   if(Journaling)
      Print(message);

   if(Log)
      WriteToFile(prefix+"Operation_Log",message);

   if(Alerts)
      Alert(message);

   if(subject!="")
      SendMail(SYMBOL+" | "+subject,_Portfolio_Comment+" | "+message);

  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool GoodDistance(string SYMBOL,int type)
  {
//=====
   double point=SymbolInfoDouble(SYMBOL,SYMBOL_POINT);

   MqlTick lasttick={0};
   if(!SymbolInfoTick(SYMBOL,lasttick))
      return(false);
   double ASK=lasttick.ask;
   double BID=lasttick.bid;

//=====
   ushort P=GetPoint(SYMBOL);
//=====
//=====
   double lastorder=0;
   int count=0;

   lastorder=LastOrderPrice(SYMBOL,type,count);
//=====
   if(lastorder>0)
     {
      if(type==OP_BUY && lastorder-ASK<(count>1?Min_Averaging_Pips:Min_Averaging_First)*P*point)
         return(false);
      if(type==OP_SELL && BID-lastorder<(count>1?Min_Averaging_Pips:Min_Averaging_First)*P*point)
         return(false);
     }
//=====     
   return(count>1 || GoodTimeFirst());
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double LastOrderPrice(const string SYMBOL,const int type,int &count)
  {
//=====
   datetime lasttime=0;
   double lastorderprice=0;
//=====
#ifdef __MQL4__   
   int orders=OrdersTotal()-1;
   for(int i=orders; i>=0; i--)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES) && OrderSymbol()==SYMBOL && OrderType()==type && OurMagic(OrderMagicNumber()) && OrderOpenTime()>lasttime)
        {
         count++;
         lasttime=OrderOpenTime();
         lastorderprice=OrderOpenPrice();
        }
     }
#endif 

#ifdef __MQL5__
   if(IsHedgingAccount())
     {
      int orders=PositionsTotal()-1;
      for(int i=orders; i>=0; i--)
        {
         //=====
         int ticket=(int)PositionGetTicket(i);
         if(!PositionSelectByTicket(ticket))continue;
         //=====
         if(OrderSymbol()==SYMBOL && OrderType()==type && OurMagic(OrderMagicNumber()) && OrderOpenTime()>lasttime)
           {
            count++;
            lasttime=OrderOpenTime();
            lastorderprice=OrderOpenPrice();
           }
        }
     }
   else
     {
      if(PositionSelect(SYMBOL))
        {
         ulong identifier=PositionGetInteger(POSITION_IDENTIFIER);

         if(HistorySelectByPosition(identifier))
           {
            int deals=HistoryDealsTotal()-1;
            for(int d=deals;d>=0;d--)
              {
               ulong ticket=HistoryDealGetTicket(d);

               if(HistoryDealGetInteger(ticket,DEAL_ENTRY)==DEAL_ENTRY_IN && HistoryDealGetInteger(ticket,DEAL_TYPE)==(type==0?DEAL_TYPE_BUY:DEAL_TYPE_SELL) && HistoryDealGetInteger(ticket,DEAL_TIME)>lasttime)
                 {
                  count++;
                  lasttime=(datetime)HistoryDealGetInteger(ticket,DEAL_TIME);
                  lastorderprice=HistoryDealGetDouble(ticket,DEAL_PRICE);
                 }
              }
           }
        }
     }

#endif      
//=====
   return(lastorderprice);
//=====
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void LastOrderData(const string SYMBOL,const int type,double &price,double &lots)
  {
   datetime lasttime=0;

#ifdef __MQL4__ 
   int orders=OrdersTotal()-1;
   for(int i=orders; i>=0; i--)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES) && OrderSymbol()==SYMBOL && OrderType()==type && OurMagic(OrderMagicNumber()) && OrderOpenTime()>lasttime)
        {
         lasttime=OrderOpenTime();
         price=OrderOpenPrice();
         lots=OrderLots();
        }
     }

   orders=OrdersHistoryTotal()-1;
   for(int i=orders; i>=0; i--)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY) && OrderSymbol()==SYMBOL && OrderType()==type && OurMagic(OrderMagicNumber()) && OrderOpenTime()>lasttime)
        {
         lasttime=OrderOpenTime();
         price=OrderOpenPrice();
         lots=OrderLots();
        }
     }

#endif 

#ifdef __MQL5__ 
   int orders=PositionsTotal()-1;
   int ticket=-1;
   for(int i=orders; i>=0; i--)
     {
      ticket=(int)PositionGetTicket(i);

      if(PositionSelectByTicket(i) && OrderSymbol()==SYMBOL && OrderType()==type && OurMagic(OrderMagicNumber()) && OrderOpenTime()>lasttime)
        {
         lasttime=OrderOpenTime();
         price=OrderOpenPrice();
         lots=OrderLots();
        }
     }
//=====
   if(HistorySelect(0,TimeCurrent()+60))
     {
      int deals=HistoryDealsTotal()-1;
      for(int d=deals;d>=0;d--)
        {
         ticket=(int)HistoryDealGetTicket(d);

         if(HistoryDealGetInteger(ticket,DEAL_ENTRY)==DEAL_ENTRY_IN && HistoryDealGetString(ticket,DEAL_SYMBOL)==SYMBOL && HistoryDealGetInteger(ticket,DEAL_TYPE)==(type==0?DEAL_TYPE_BUY:DEAL_TYPE_SELL) && HistoryDealGetInteger(ticket,DEAL_TIME)>lasttime)
           {
            lots=HistoryDealGetDouble(ticket,DEAL_VOLUME);
            lasttime=(datetime)HistoryDealGetInteger(ticket,DEAL_TIME);
            price=HistoryDealGetDouble(ticket,DEAL_PRICE);
           }
        }
     }
#endif 


//=====
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
datetime LastOrderTime(string SYMBOL,int type)
  {
   datetime lasttime=0;

#ifdef __MQL4__
   int orders=OrdersTotal()-1;
   for(int i=orders; i>=0; i--)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES) && OrderSymbol()==SYMBOL && OrderType()==type && OurMagic(OrderMagicNumber()) && OrderOpenTime()>lasttime)
         lasttime=OrderOpenTime();
     }

   orders=OrdersHistoryTotal()-1;
   for(int i=orders; i>=0; i--)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY) && OrderSymbol()==SYMBOL && OrderType()==type && OurMagic(OrderMagicNumber()) && OrderOpenTime()>lasttime)
         lasttime=OrderOpenTime();
     }
#endif

#ifdef __MQL5__
   int orders=PositionsTotal()-1;
   int ticket=-1;
   for(int i=orders; i>=0; i--)
     {
      ticket=(int)PositionGetTicket(i);

      if(PositionSelectByTicket(i) && OrderSymbol()==SYMBOL && OrderType()==type && OurMagic(OrderMagicNumber()) && OrderOpenTime()>lasttime)
         lasttime=OrderOpenTime();

     }
//=====
   if(HistorySelect(0,TimeCurrent()+60))
     {
      int deals=HistoryDealsTotal()-1;
      for(int d=deals;d>=0;d--)
        {
         ticket=(int)HistoryDealGetTicket(d);

         if(HistoryDealGetInteger(ticket,DEAL_ENTRY)==DEAL_ENTRY_IN && HistoryDealGetString(ticket,DEAL_SYMBOL)==SYMBOL && HistoryDealGetInteger(ticket,DEAL_TYPE)==(type==0?DEAL_TYPE_BUY:DEAL_TYPE_SELL) && HistoryDealGetInteger(ticket,DEAL_TIME)>lasttime)
            lasttime=(datetime)HistoryDealGetInteger(ticket,DEAL_TIME);

        }
     }

#endif      
   return(lasttime);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double CountProfit(string SYMBOL,int type)
  {
//=====
   double profit=0;
//=====
   int orders=0;
#ifdef __MQL4__ orders=OrdersTotal()-1; #endif
#ifdef __MQL5__ orders=PositionsTotal()-1; #endif
//=====
   for(int i=orders;i>=0;i--)
     {
#ifdef __MQL4__ if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) #endif
#ifdef __MQL5__
      int posticket=(int)PositionGetTicket(i);
      if(!PositionSelectByTicket(posticket))
#endif
         continue;
      if(OrderSymbol()==SYMBOL && OrderType()==type && OurMagic(OrderMagicNumber()))
         profit+=OrderProfit()+OrderSwap()+OrderCommission();
     }
   return(profit);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double CountVolume(string SYMBOL,int type)
  {
//=====
   double volume=0;
//=====
   int orders=0;
#ifdef __MQL4__ orders=OrdersTotal()-1; #endif
#ifdef __MQL5__ orders=PositionsTotal()-1; #endif
//=====
   for(int i=orders;i>=0;i--)
     {
#ifdef __MQL4__ if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) #endif
#ifdef __MQL5__
      int posticket=(int)PositionGetTicket(i);
      if(!PositionSelectByTicket(posticket))
#endif
         continue;
      if(OrderSymbol()==SYMBOL && OrderType()==type && OurMagic(OrderMagicNumber()))
         volume+=OrderLots();
     }
   return(volume);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int CountOrders(string SYMBOL,int type)
  {
//=====
   int number=0;
//=====
#ifdef __MQL4__
   int orders=OrdersTotal()-1;
   for(int i=orders; i>=0; i--)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES) && OrderSymbol()==SYMBOL && OrderType()==type && OurMagic(OrderMagicNumber()))
         number++;
     }
#endif   

#ifdef __MQL5__
   if(IsHedgingAccount())
     {
      int orders=PositionsTotal()-1;
      for(int i=orders; i>=0; i--)
        {
         //=====
         int ticket=(int)PositionGetTicket(i);
         if(!PositionSelectByTicket(ticket))continue;
         //=====
         if(OrderSymbol()==SYMBOL && OrderType()==type && OurMagic(OrderMagicNumber()))
            number++;
        }
     }
   else
     {
      if(PositionSelect(SYMBOL))
        {
         ulong identifier=PositionGetInteger(POSITION_IDENTIFIER);

         if(HistorySelectByPosition(identifier))
           {
            int deals=HistoryDealsTotal()-1;
            for(int d=deals;d>=0;d--)
              {
               ulong ticket=HistoryDealGetTicket(d);

               if(HistoryDealGetInteger(ticket,DEAL_ENTRY)==DEAL_ENTRY_IN && HistoryDealGetInteger(ticket,DEAL_TYPE)==(type==0?DEAL_TYPE_BUY:DEAL_TYPE_SELL))
                  number++;
              }
           }
        }
     }
#endif
//=====
   return(number);
//=====
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CloseOrders(string SYMBOL,int type,string reason)
  {
   int orders=0;
#ifdef __MQL4__ orders=OrdersTotal()-1; #endif
#ifdef __MQL5__ orders=PositionsTotal()-1; #endif
//=====
   for(int i=orders;i>=0;i--)
     {
#ifdef __MQL4__ if(!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) #endif
#ifdef __MQL5__
      int posticket=(int)PositionGetTicket(i);
      if(!PositionSelectByTicket(posticket))
#endif
         continue;
      if(OrderSymbol()==SYMBOL && OrderType()==type && OurMagic(OrderMagicNumber()))
        {
         ResetLastError();

         //=====
         ushort P=GetPoint(SYMBOL);
         //=====

         color arrow_color=0;if(OrderType()==OP_BUY)arrow_color=clrBlue;if(OrderType()==OP_SELL)arrow_color=clrGreen;

         bool Closing=OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),int(Slippage*P),arrow_color);

         if(!Closing)
            Informer("ERROR: "+GetTradeErrorDescription(GetLastError()),SYMBOL);

         else
            Informer("Order successfully closed. "+reason,SYMBOL);
        }
     }
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool GVsFlush()
  {
//=====  
   if(MQLInfoInteger(MQL_TESTER) || Use_MT4_GVs)
     {
      GlobalVariablesFlush();
      return(true);
     }

//=====
   ResetLastError();

   int handle=FileOpen(prefix+"GVs.csv",FILE_WRITE|FILE_CSV|FILE_ANSI,",");
   if(handle!=INVALID_HANDLE)
     {
      for(int i=0;i<ArraySize(GVs);i++)
        {
         if(GVs[i].value!=0 && TimeLocal()-GVs[i].lastused<=GVs_Life_Period)
            FileWrite(handle,GVs[i].name,DoubleToString(GVs[i].value),(string)(int)GVs[i].lastused);
        }
      FileClose(handle);
      return(true);
     }

//=====
   Informer("ERROR: Can Not open and update GVs file!!! "+(string)GetLastError(),_Symbol,"Can not open GVs File.");
   return(false);
//=====     
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
bool GVsRead()
  {
//=====  
   if(MQLInfoInteger(MQL_TESTER) || Use_MT4_GVs)
      return(true);

//=====
   if(FileIsExist(prefix+"GVs.csv"))
     {
      int handle=FileOpen(prefix+"GVs.csv",FILE_READ|FILE_CSV|FILE_ANSI);
      if(handle!=INVALID_HANDLE)
        {
         FileSeek(handle,0,SEEK_SET);

         int size=0;

         while(!FileIsEnding(handle))
           {
            string record=FileReadString(handle);

            string splitted[];

            int cells=StringSplit(record,StringGetCharacter(",",0),splitted);

            if(cells==3)
              {
               size++;
               ArrayResize(GVs,size);

               GVs[size-1].name=splitted[0];
               GVs[size-1].value=StringToDouble(splitted[1]);
               GVs[size-1].lastused=(datetime)StringToInteger(splitted[2]);

               // Print(GVs[size-1].name+" | "+(string)GVs[size-1].value);
              }
           }

         FileClose(handle);
         return(true);
        }
      else
         return(false);
     }

//=====     
   return(true);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void GVSet(string name,double value)
  {
//=====  
   if(MQLInfoInteger(MQL_TESTER) || Use_MT4_GVs)
     {
      GlobalVariableSet(prefix+name,value);
      return;
     }

//=====   
   for(int i=0;i<ArraySize(GVs);i++)
     {
      if(GVs[i].name==name)
        {
         if(GVs[i].value!=value)
           {
            GVs[i].value=value;

            //=====
            flush=true;
           }

         GVs[i].lastused=TimeLocal();
         return;
        }
     }

//===== 
   for(int i=0;i<ArraySize(GVs);i++)
     {
      if(GVs[i].value==0 && GVs[i].name=="")
        {
         GVs[i].name=name;
         GVs[i].value=value;
         GVs[i].lastused=TimeLocal();

         //=====
         flush=true;

         return;
        }
     }

//=====   
   int size=ArraySize(GVs);

   ArrayResize(GVs,size+1);

   GVs[size].name=name;
   GVs[size].value=value;
   GVs[size].lastused=TimeLocal();

//=====
   flush=true;

//=====
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double GVGet(string name)
  {
//=====  
   if(MQLInfoInteger(MQL_TESTER) || Use_MT4_GVs)
      return(GlobalVariableGet(prefix+name));

//=====
   for(int i=0;i<ArraySize(GVs);i++)
     {
      if(GVs[i].name==name)
        {
         GVs[i].lastused=TimeLocal();
         return(GVs[i].value);
        }
     }

//=====
   return(0);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void GVDel(string name)
  {
//=====  
   if(MQLInfoInteger(MQL_TESTER) || Use_MT4_GVs)
     {
      GlobalVariableDel(prefix+name);
      return;
     }

//=====
   for(int i=0;i<ArraySize(GVs);i++)
     {
      if(GVs[i].name==name)
        {
         GVs[i].name="";
         GVs[i].value=0;
         GVs[i].lastused=0;

         //===== 
         flush=true;
        }
     }
//=====   
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void DeleteGlobalVariables(string removeonly="")
  {
   if(MQLInfoInteger(MQL_TESTER) || Use_MT4_GVs)
     {
      int vars=GlobalVariablesTotal()-1;
      for(int i=vars; i>=0;i--)
        {
         string name=GlobalVariableName(i);
         if(StringFind(name,prefix,0)>=0 && (removeonly=="" || (removeonly!="" && StringFind(name,removeonly,0)>=0)))
            GlobalVariableDel(name);
        }
      return;
     }

//=====
   for(int i=0;i<ArraySize(GVs);i++)
     {
      if(removeonly=="" || (removeonly!="" && StringFind(GVs[i].name,removeonly,0)>=0))
        {
         GVs[i].name="";
         GVs[i].value=0;
         GVs[i].lastused=TimeLocal();

         //=====
         flush=true;
        }
     }
//=====     
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double MarketOrder(string SYMBOL,int TYPE,double LOT,string reason)
  {
   int cmd=TYPE;

   double volume=CheckLot(SYMBOL,LOT);
   double marginrequired=0;

   bool margincheck=true;

#ifdef __MQL4__ marginrequired=MarketInfo(SYMBOL,MODE_MARGINREQUIRED)*volume; #endif
#ifdef __MQL5__ margincheck=OrderCalcMargin(TYPE==OP_BUY?ORDER_TYPE_BUY:ORDER_TYPE_SELL,SYMBOL,volume,TYPE==OP_BUY?SymbolInfoDouble(SYMBOL,SYMBOL_ASK):SymbolInfoDouble(SYMBOL,SYMBOL_BID),marginrequired); #endif

   if(marginrequired>AccountInfoDouble(ACCOUNT_MARGIN_FREE) || !margincheck)
     {
      if(GVGet("NO MARGIN")==0)
        {
         Informer("Market Order: Can not open a trade. Not enough free margin to open "+(string)volume+" on "+SYMBOL,SYMBOL);
         GVSet("NO MARGIN",1);
        }
      return(volume);
     }

   GVDel("NO MARGIN");

//=====
   ushort P=GetPoint(SYMBOL);
//=====

   int slippage=int(Slippage*P);
   int magic=(int)Magic;
   datetime expiration=0;
   color arrow_color=0;if(TYPE==OP_BUY)arrow_color=clrBlue;if(TYPE==OP_SELL)arrow_color=clrGreen;

   int Ticket=-1;
   ResetLastError();

   double price=0;
   double point=SymbolInfoDouble(SYMBOL,SYMBOL_POINT);
   int digits=(int)SymbolInfoInteger(SYMBOL,SYMBOL_DIGITS);

   Informer("Market Order: Trying to place an order... "+reason,SYMBOL);
   double ask=SymbolInfoDouble(SYMBOL,SYMBOL_ASK);
   double bid=SymbolInfoDouble(SYMBOL,SYMBOL_BID);

   if(TYPE==OP_BUY)price=ask;
   if(TYPE==OP_SELL)price=bid;
   Ticket=OrderSend(SYMBOL,cmd,volume,NormalizeDouble(price,digits),slippage,0,0,_Portfolio_Comment,magic,expiration,arrow_color);
   if(Ticket<0)
      Informer("ERROR: "+GetTradeErrorDescription(GetLastError()),SYMBOL);

   return(volume);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double CheckLot(string SYMBOL,double LOT)
  {
   double LotToOpen=0;

   LotToOpen=MathCeil(LOT/SymbolInfoDouble(SYMBOL,SYMBOL_VOLUME_STEP))*SymbolInfoDouble(SYMBOL,SYMBOL_VOLUME_STEP);
   if(LotToOpen<SymbolInfoDouble(SYMBOL,SYMBOL_VOLUME_MIN))LotToOpen=SymbolInfoDouble(SYMBOL,SYMBOL_VOLUME_MIN);
   if(LotToOpen>SymbolInfoDouble(SYMBOL,SYMBOL_VOLUME_MAX))LotToOpen=SymbolInfoDouble(SYMBOL,SYMBOL_VOLUME_MAX);
   LotToOpen=NormalizeDouble(LotToOpen,2);
   return(LotToOpen);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
double CountClosedPnL(string SYMBOL,int type,datetime starttime,datetime endtime)
  {
//=====
   double PnL=0;

//=====   
#ifdef __MQL4__
   int orders=OrdersHistoryTotal()-1;
   for(int i=orders;i>=0;i--)
     {
      if(OrderSelect(i,SELECT_BY_POS,MODE_HISTORY) && OrderSymbol()==SYMBOL && OrderType()==type && OurMagic(OrderMagicNumber()))
        {
         if(OrderCloseTime()>=starttime && OrderCloseTime()<=endtime)
            PnL+=OrderProfit()+OrderSwap()+OrderCommission();
        }
     }
#endif 

#ifdef __MQL5__
   if(HistorySelect(starttime,endtime))
     {
      int deals=HistoryDealsTotal()-1;
      for(int d=deals;d>=0;d--)
        {
         ulong ticket=HistoryDealGetTicket(d);

         if(HistoryDealGetString(ticket,DEAL_SYMBOL)!=SYMBOL)
            continue;
         if(HistoryDealGetInteger(ticket,DEAL_ENTRY)==DEAL_ENTRY_OUT && HistoryDealGetInteger(ticket,DEAL_TYPE)==(type==1?DEAL_TYPE_BUY:DEAL_TYPE_SELL))
            PnL+=HistoryDealGetDouble(ticket,DEAL_PROFIT);
        }
     }
#endif     
//=====     
   return(PnL);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int WriteToFile(string NAME,string text)
  {
   string name=NAME+".csv";
   int handle=FileOpen(name,FILE_READ|FILE_WRITE|FILE_CSV);
   FileSeek(handle,0,SEEK_END);
   int recorded=(int)FileWrite(handle,text);
   FileClose(handle);
   return(recorded);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CreateTextLabel(string name,string text,string tooltip,string fontname,int fontsize,color textcolor,int xdistance,int ydistance,ENUM_BASE_CORNER corner,ENUM_ANCHOR_POINT anchor,long chartid,int subwindow)
  {
   string NAME=prefix+name;
   if(ObjectFind(chartid,NAME)!=subwindow)
      ObjectCreate(chartid,NAME,OBJ_LABEL,subwindow,0,0);

   ObjectSetInteger(chartid,NAME,OBJPROP_CORNER,corner);
   ObjectSetInteger(chartid,NAME,OBJPROP_ANCHOR,anchor);
   ObjectSetInteger(chartid,NAME,OBJPROP_XDISTANCE,xdistance);
   ObjectSetInteger(chartid,NAME,OBJPROP_YDISTANCE,ydistance);
   ObjectSetInteger(chartid,NAME,OBJPROP_COLOR,textcolor);
   ObjectSetString(chartid,NAME,OBJPROP_TOOLTIP,tooltip);
   ObjectSetString(chartid,NAME,OBJPROP_TEXT,text);
   ObjectSetString(chartid,NAME,OBJPROP_FONT,fontname);
   ObjectSetInteger(chartid,NAME,OBJPROP_FONTSIZE,fontsize);
   ObjectSetInteger(chartid,NAME,OBJPROP_SELECTABLE,false);
   ObjectSetInteger(chartid,NAME,OBJPROP_SELECTED,false);
   ObjectSetInteger(chartid,NAME,OBJPROP_HIDDEN,true);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void CreateImageLabel(string name,string tooltip,color col,int height,int width,int xdistance,int ydistance,ENUM_BASE_CORNER corner,ENUM_ANCHOR_POINT anchor,long chartid,int subwindow)
  {
   string NAME=prefix+name;
   if(ObjectFind(chartid,NAME)!=subwindow)
      ObjectCreate(chartid,NAME,OBJ_RECTANGLE_LABEL,subwindow,0,0);

   ObjectSetInteger(chartid,NAME,OBJPROP_CORNER,corner);
   ObjectSetInteger(chartid,NAME,OBJPROP_ANCHOR,anchor);
   ObjectSetInteger(chartid,NAME,OBJPROP_XDISTANCE,xdistance);
   ObjectSetInteger(chartid,NAME,OBJPROP_YDISTANCE,ydistance);
   ObjectSetInteger(chartid,NAME,OBJPROP_COLOR,col);
   ObjectSetInteger(chartid,NAME,OBJPROP_BGCOLOR,col);
   ObjectSetInteger(chartid,NAME,OBJPROP_XSIZE,width);
   ObjectSetInteger(chartid,NAME,OBJPROP_YSIZE,height);
   ObjectSetString(chartid,NAME,OBJPROP_TOOLTIP,tooltip);
   ObjectSetInteger(chartid,NAME,OBJPROP_SELECTABLE,false);
   ObjectSetInteger(chartid,NAME,OBJPROP_SELECTED,false);
   ObjectSetInteger(chartid,NAME,OBJPROP_HIDDEN,true);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
void DeleteObjects(string removeonly="",bool redraw=true,long chartid=0,int subwindow=-1,int type=-1)
  {
   int objects=ObjectsTotal(chartid,subwindow,type)-1;
   for(int i=objects;i>=0;i--)
     {
      string name=ObjectName(chartid,i,subwindow,type);
      if(StringFind(name,prefix,0)>=0 && (removeonly=="" || (removeonly!="" && StringFind(name,removeonly,0)>=0)))
         ObjectDelete(chartid,name);
     }
   if(redraw)
      ChartRedraw(chartid);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string DeinitReason(int reason)
  {
   if(reason==0)return("ExpertRemove() function called.");
   if(reason==1)return("Removed from chart.");
   if(reason==2)return("Recompiled.");
   if(reason==3)return("Chart Symbol/TimeFrame changed.");
   if(reason==4)return("Chart Closed.");
   if(reason==5)return("Input parameters changed.");
   if(reason==6)return("Account changed.");
   if(reason==7)return("New template applied.");
   if(reason==8)return("Initialization failed.");
   if(reason==9)return("Terminal Closed.");
   return("Uknown reason.");
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
string GetTradeErrorDescription(int retcode)
  {
   string ErrorDescription="???";
//---
   switch(retcode)
     {
#ifdef __MQL4__
      case ERR_NO_ERROR                   :     ErrorDescription = "NO Error. Everything should be good :)";                                  break;
      case ERR_NO_RESULT                  :     ErrorDescription = "No error returned, but the result is unknown";                            break;
      case ERR_COMMON_ERROR               :     ErrorDescription = "Common error";                                                            break;
      case ERR_INVALID_TRADE_PARAMETERS   :     ErrorDescription = "Invalid trade parameters";                                                break;
      case ERR_SERVER_BUSY                :     ErrorDescription = "Trade server is busy";                                                    break;
      case ERR_OLD_VERSION                :     ErrorDescription = "Old version of the client terminal";                                      break;
      case ERR_NO_CONNECTION              :     ErrorDescription = "No connection with trade server";                                         break;
      case ERR_NOT_ENOUGH_RIGHTS          :     ErrorDescription = "Not enough rights";                                                       break;
      case ERR_TOO_FREQUENT_REQUESTS      :     ErrorDescription = "Too frequent requests";                                                   break;
      case ERR_MALFUNCTIONAL_TRADE        :     ErrorDescription = "Malfunctional trade operation";                                           break;
      case ERR_ACCOUNT_DISABLED           :     ErrorDescription = "Account disabled";                                                        break;
      case ERR_INVALID_ACCOUNT            :     ErrorDescription = "Invalid account";                                                         break;
      case ERR_TRADE_TIMEOUT              :     ErrorDescription = "Trade timeout";                                                           break;
      case ERR_INVALID_PRICE              :     ErrorDescription = "Invalid price";                                                           break;
      case ERR_INVALID_STOPS              :     ErrorDescription = "Invalid stops";                                                           break;
      case ERR_INVALID_TRADE_VOLUME       :     ErrorDescription = "Invalid trade volume";                                                    break;
      case ERR_MARKET_CLOSED              :     ErrorDescription = "Market is closed";                                                        break;
      case ERR_TRADE_DISABLED             :     ErrorDescription = "Trade is disabled";                                                       break;
      case ERR_NOT_ENOUGH_MONEY           :     ErrorDescription = "Not enough money";                                                        break;
      case ERR_PRICE_CHANGED              :     ErrorDescription = "Price changed";                                                           break;
      case ERR_OFF_QUOTES                 :     ErrorDescription = "Off quotes";                                                              break;
      case ERR_BROKER_BUSY                :     ErrorDescription = "Broker is busy";                                                          break;
      case ERR_REQUOTE                    :     ErrorDescription = "Requote";                                                                 break;
      case ERR_ORDER_LOCKED               :     ErrorDescription = "Order is locked";                                                         break;
      case ERR_LONG_POSITIONS_ONLY_ALLOWED:     ErrorDescription = "Long positions only allowed";                                             break;
      case ERR_TOO_MANY_REQUESTS          :     ErrorDescription = "Too many requests";                                                       break;
      case ERR_TRADE_MODIFY_DENIED        :     ErrorDescription = "Modification denied because order too close to market";                   break;
      case ERR_TRADE_CONTEXT_BUSY         :     ErrorDescription = "Trade context is busy";                                                   break;
      case ERR_TRADE_EXPIRATION_DENIED    :     ErrorDescription = "Expirations are denied by broker";                                        break;
      case ERR_TRADE_TOO_MANY_ORDERS      :     ErrorDescription = "Too many open and pending orders (more than allowed)";                    break;
      case ERR_TRADE_HEDGE_PROHIBITED     :     ErrorDescription = "Can not open opposite to the existing order. Hedging is disabled";        break;
      case ERR_TRADE_PROHIBITED_BY_FIFO   :     ErrorDescription = "An attempt to close an order contravening the FIFO rule";                 break;

      default                             :    ErrorDescription="UNKNOWN ERROR. CHECK DOCUMENTATION.";
#endif
     }
   return(ErrorDescription);
  }
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
